<?php
/**
 * 
 * @param $username
 * @param $password
 */
function fn_verify_user_password($username, $password)
{
	$lpass = md5($password);
	$us = get_user($username);
	$passwd = $us['passwd'];
	if ( $passwd == $lpass )
		return true;
	else
		return false;
}
/**
 * ricava i dati di un utente
 * @param $user nome utente
 * @return array che contiene i dati dell' utente
 **/
function get_user($user, $usecache = true)
{
	static $usercache = array();
	global $_FN;
	if ( $usecache && isset($usercache[$user]) )
		return $usercache[$user];
	$table = new XMLTable("fndatabase","users","{$_FN['datadir']}");
	$UserValues = $table->GetRecordByPrimaryKey($user);
	
	if (  !$UserValues )
		return null;
	$usercache[$user] = $UserValues;
	
	return $usercache[$user];
}
/**
 * Ritorna la lista degli utenti
 *
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @return array che contiene la lista degli utenti
 */
function get_userlist()
{
	global $_FN;
	$table = new XMLTable("fndatabase","users","{$_FN['datadir']}");
	$userlist = $table->GetRecords();
	$users = array();
	foreach ( $userlist as $us )
	{
		$users[] = $us[$table->primarykey];
	}
	fn_natsort($users);
	return $users;
}
/**
 * Restituisce il codice di controllo decodificato MD5 di un utente
 *
 * Restituisce il codice di controllo dell'utente passato come parametro,
 * decodificandolo con algoritmo MD5.
 *
 * @author Simone Vellei <simone_vellei@users.sourceforge.net>
 *
 * @param string $user Nome assoluto del profilo utente da elaborare
 * @return string Codice di controllo decodificato MD5 dell'utente
 */
function getsecid($user)
{
	$uservalues = get_user($user);
	$pass = $uservalues['passwd'];
	if (  !isset($uservalues['passwd']) )
		return null;
	return md5($user . $pass);
}
/**
 * Restituisce il codice di controllo codificato MD5 di un utente
 *
 * Restituisce il codice di controllo dell'utente passato come parametro,
 * mantenendo la codifica MD5.
 *
 * @author Simone Vellei <simone_vellei@users.sourceforge.net>
 *
 * @param string $user Nome assoluto del profilo utente da elaborare
 * @return string Codice di controllo codificato MD5 dell'utente
 */
function getpass($user)
{
	$uservalues = get_user($user);
	if (  !isset($uservalues['passwd']) )
		return null;
	$pass = $uservalues['passwd'];
	return $pass;
}
/**
 * 
 * @param string $user
 * @param array $newvalues
 */
function fn_add_user($user, $newvalues)
{
	global $_FN;
	if ( $user != "" )
	{
		$table = new XMLTable("fndatabase","users","{$_FN['datadir']}");
		$newvalues['passwd'] = md5($newvalues['passwd']);
		$table->InsertRecord($newvalues);
	}
}
/**
 * 
 * @param string $user
 * @param array $newvalues
 */
function fn_update_user($user, $newvalues)
{
	global $_FN;
	if ( $user != "" )
	{
		$table = new XMLTable("fndatabase","users","{$_FN['datadir']}");
		if ($newvalues['passwd'] != "")
			$newvalues['passwd'] = md5($newvalues['passwd']);
		else
			unset($newvalues['passwd']);
		$newvalues = $table->UpdateRecord($newvalues);
		return $newvalues;
	}
	return false;
}
/**
 * deleta user
 * @param string $user
 */
function fn_delete_user($user)
{
	global $_FN;
	if ( $user != "" )
	{
		$table = new XMLTable("fndatabase","users","{$_FN['datadir']}");
		$table->DelRecord($user);
		if ( file_exists("{$_FN['datadir']}/fndatabase/users/" . $user) )
		{
			remove_dir_rec("{$_FN['datadir']}/fndatabase/users/" . $user);
		}
	}
}
?>