<?php
/**
 * script di avvio per Flatnux
 *
 * Questo file contiene lo script che viene eseguito ogni volta che
 *
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
/**
 * Contiene funzioni condivise tra le sezioni e il core di FlatNux
 */
// previene che il blocco sia eseguito direttamente e redirige a index.php
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
if ( $_FN['datadir'] == "" )
	$_FN['datadir'] = "misc";
if ( file_exists("{$_FN['datadir']}/firstinstall") )
{
	Header("Location: install.php");
	die();
}
//AUTOBUILD -->
$listlanguages = explode(",",$_FN['languages']);
if (  !is_writable("{$_FN['datadir']}/") )
{
	?>
<pre>
<h1><?php
	echo _ERROR_PERM?></h1>
<h4><?php
	echo _ERROR_PERM_FIX1?></h4>
<?php
	echo $_FN['datadir']?>/


<h4><?php
	echo _ERROR_PERM_FIX2?></h4>
  cd <?php
	echo dirname($_SERVER['SCRIPT_FILENAME'])?>

chmod -R a+w <?php
	echo $_FN['datadir']?>/
</pre>
<?php
	exit();
}
InitFNTables();
if (  !file_exists("{$_FN['datadir']}/index.html") )
	write_static_index("{$_FN['datadir']}/index.html");
if (  !file_exists("{$_FN['datadir']}/fndatabase/avatars") && file_exists("include/install/fndatabase/avatars") )
{
	mkdir("{$_FN['datadir']}/fndatabase/avatars");
	fn_copy_dir("include/install/fndatabase/avatars","{$_FN['datadir']}/fndatabase/avatars",0777);
}
if (  !file_exists("{$_FN['datadir']}/fndatabase/avatars.php") && file_exists("include/install/fndatabase/avatars.php") )
	copy("include/install/fndatabase/avatars.php","{$_FN['datadir']}/fndatabase/avatars.php");
	//messaggi di flatnux
if (  !file_exists("{$_FN['datadir']}/messages") )
{
	mkdir("{$_FN['datadir']}/messages");
}
if (  !file_exists("{$_FN['datadir']}/messages/{$_FN['lang']}") )
{
	mkdir("{$_FN['datadir']}/messages/{$_FN['lang']}");
}
if (  !file_exists("{$_FN['datadir']}/messages/{$_FN['lang']}/mail_confirmation_message.txt") )
{
	$h = fopen("{$_FN['datadir']}/messages/{$_FN['lang']}/mail_confirmation_message.txt","w");
	fwrite($h,_IST_REG_MAIL . "\n" . "!CONFIRMREGISTRATIONADDRESS!");
	fclose($h);
}
if (  !file_exists("{$_FN['datadir']}/messages/{$_FN['lang']}/mail_welcome_message.txt") )
{
	$h = fopen("{$_FN['datadir']}/messages/{$_FN['lang']}/mail_welcome_message.txt","w");
	fwrite($h,_BENVE . " !USERNAME!" . ".\n" . _FORAREG);
	fclose($h);
}
//---mod rewrite ----->
//debug mod_rewrite
/*
foreach ($_GET as $k=>$v)
	echo "$k=$v&amp;";
*/
//dprint_r ($_SERVER);
if ( $_FN['enable_mod_rewrite'] > 0 )
{
	//echo "zz";
	header("Cache-Control: no-cache");
	header("Pragma: no-cache");
	if ( function_exists('apache_get_modules') )
	{
		$modules = apache_get_modules();
		//if (is_admin())
		//	dprint_r($modules);
		$mod_rewrite = in_array('mod_rewrite',$modules);
	}
	else
	{
		$mod_rewrite = getenv('HTTP_MOD_REWRITE') == 'On' ? true : false;
	}
	if ( $_FN['enable_mod_rewrite'] > 1 )
		$mod_rewrite = true;
	if (  !$mod_rewrite )
	{
		$_FN['enable_mod_rewrite'] = 0;
		if ( is_admin() )
		{
			jsalert("You have mod_rewrite enabled on flatnux, but is not enabled on your server");
		}
	}
	$RewriteBase = getparam("PHP_SELF",PAR_SERVER,SAN_FLAT);
	if ( $RewriteBase == "" )
		$RewriteBase = "/";
	else
	{
		$RewriteBase = dirname($RewriteBase) . "/";
		if ( $RewriteBase == "//" )
			$RewriteBase = "/";
	}
	$sthtaccess = "# BEGIN Flatnux
<IfModule mod_rewrite.c>
RewriteEngine On
RewriteBase $RewriteBase
RewriteRule (^google[0-9a-f]{16}).html $1.html [L,QSA,NC]
RewriteRule (^[0-9a-zA-z_]+).html index.php?mod=$1 [L,QSA,NC]
RewriteRule (^[0-9a-zA-z_]+)\-([0-9a-zA-z_]+)-([0-9a-zA-z_]+).html index.php?mod=$1&op=$2&id=$3 [L,QSA,NC]
RewriteRule (^[0-9a-zA-z_]+)\-([0-9a-zA-z_]+).html index.php?mod=$1&op=$2 [L,QSA,NC]
RewriteRule ([^\/^\-]+)\-([0-9a-zA-z_]+)-([0-9a-zA-z_]+).([a-zA-z][a-zA-z]).html index.php?mod=$1&op=$2&id=$3&lang=$4 [L,QSA,NC]
RewriteRule ([^\/^\-]+)\-([0-9a-zA-z_]+).([a-zA-z][a-zA-z]).html index.php?mod=$1&op=$2&lang=$3 [L,QSA,NC]
RewriteRule ([^\/^\-]+)\.([a-zA-z][a-zA-z]).html index.php?mod=$1&lang=$2 [L,QSA,NC]
</IfModule>
# END Flatnux
";
	//dprint_r($sthtaccess);
	if (  !file_exists(".htaccess") )
		$htcontents = "";
	else
		$htcontents = file_get_contents(".htaccess");
	if ( strpos($htcontents,$sthtaccess) === false )
	{
		if ( strpos($htcontents,"# BEGIN Flatnux") === false )
		{
			$newfilestring = $htcontents . "\n" . $sthtaccess;
		}
		else
		{
			$newfilestring = preg_replace("/# BEGIN Flatnux(.*)# END Flatnux/s",str_replace('$','\$',$sthtaccess),$htcontents);
		}
		$fph = fopen(".htaccess","w");
		if (  !$fph )
		{
			echo ".htacces is not writable";
		}
		else
		{
			fwrite($fph,$newfilestring);
			fclose($fph);
		}
	}
}
//---mod rewrite -----<
//creo le cartelle per le varie lingue ...
foreach ( $listlanguages as $l )
{
	if (  !file_exists("{$_FN['datadir']}/$l") )
		mkdir("{$_FN['datadir']}/$l");
}
//se non ci sono utenti
if ( count_users() == 0 )
{
	echo "<p style='background: red;text-align:center; color: white;   font-size: 12px; font-weight: bold; font-family:  Helvetica;'><img border='0' src='images/icons/warning.png'>&nbsp;" . _FIRSTUSERWARNING . "</p>";
}
if (  !file_exists("{$_FN['datadir']}/motd." . $_FN['lang'] . ".php") )
{
	$fp = fopen("{$_FN['datadir']}/motd." . $_FN['lang'] . ".php","w");
	fwrite($fp,_MOTDMESS);
	fclose($fp);
}
//<-- AUTOBUID

?>