<?php
/**
 * Sets the global variables depending on the environment
 *
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */

//-----config.php------>
global $sitename, $keywords, $theme, $admin, $admin_mail;
global $lang, $siteurl, $jet_lag, $languages, $lang_auto_switch;
global $htmleditor, $registration_by_email, $enable_log_email, $log_email_address, $site_email_address;
global $home_section, $show_welcome_message, $showaccesskey, $maintenance, $remember_login;
global $syntax_highlighting, $fn_datadir, $enable_registration, $enable_mod_rewrite, $enable_account_deletion;
global $cc_theme,$fn_timezone;
//-----config.php------<
if (!defined("_AUTH"))
	define("_AUTH","local");

if (strpos ( strtolower ( $_SERVER ['SCRIPT_NAME'] ), strtolower ( basename ( __FILE__ ) ) ))
{
	header ( "Location: ../../index.php" );
	die ( "..." );
}
global $_FN;
if (!empty($fn_timezone))
	date_default_timezone_set($fn_timezone);

//memorizzo i valori orignali del config.php
$_FN ['theme_default'] = $theme;
//tema controlcenter
if (! isset ( $cc_theme ) || $cc_theme == "")
{
	if (file_exists ( "themes/base" ))
		$cc_theme = "base";
	else
		$cc_theme = $theme;
}
$_FN ['cc_theme_default'] = $cc_theme;
$_FN ['showaccesskey_default'] = $showaccesskey;
$_FN ['lang_default'] = $lang;
$_FN ['enable_account_deletion'] = $enable_account_deletion;
$_FN ['fneditmode'] = false;
$php_self = isset ( $_SERVER ['PHP_SELF'] ) ? $_SERVER ['PHP_SELF'] : "";
$_FN ['self'] = $php_self;
$home_section = sectionlocation ( $home_section );

strstr ( PHP_OS, "WIN" ) ? $slash = "\\" : $slash = "/";
$_FN ['slash'] = $slash;
//--compongo in automatico siteurl ---------->
if ($siteurl == "")
{
	//$php_self = getparam("PHP_SELF", PAR_SERVER, SAN_FLAT);
	$dirname = dirname ( $php_self );
	if (isset ( $_SERVER ['SCRIPT_FILENAME'] ))
		$serverpath = dirname ( $_SERVER ['SCRIPT_FILENAME'] );
	elseif (isset ( $_SERVER ['PATH_TRANSLATED'] ))
	{
		$_SERVER ['SCRIPT_FILENAME'] = $_SERVER ['PATH_TRANSLATED'];
		$serverpath = dirname ( $_SERVER ['PATH_TRANSLATED'] );
	}
	while ( ! file_exists ( $serverpath . "/include/flatnux.php" ) )
	{
		$dirname = dirname ( preg_replace ( '/\/$/', '', $dirname ) );
		$serverpath = dirname ( preg_replace ( '/\/$/', '', $serverpath ) );
	}
	
	if ($dirname == "/" || $dirname == "\\")
		$dirname = "";
	// server windows
	$dirname = str_replace ( "\\", "/", $dirname );
	
	$protocol = "http://";
	if (isset ( $_SERVER ['HTTPS'] ) && $_SERVER ['HTTPS'] == "on")
		$protocol = "https://";
	
	$siteurl = "$protocol" . $_SERVER ['HTTP_HOST'] . $dirname;
	if (substr ( $siteurl, strlen ( $siteurl ) - 1, 1 ) != "/")
	{
		$siteurl = $siteurl . "/";
	}
	//die ($siteurl);
}
//--compongo in automatico siteurl ----------<


//--urlcookie---------------------->
global $urlcookie;
if ($urlcookie == "")
{
	$url = $php_self;
	$path = pathinfo ( $url );
	$url = $path ["dirname"];
	if ($url == "")
		$url = "/";
	$urlcookie = str_replace ( "\\", "/", $url );
}
$_FN ['urlcookie'] = $urlcookie;
$time = time () + 999999999;
//--urlcookie----------------------<


//lingua---->
$cookie_session = getparam ( "session", PAR_COOKIE, SAN_PARA );
$cookie_lang = getparam ( "lang", PAR_COOKIE, SAN_HTML );
$cookie_lang = preg_replace ( "/([^A-Za-z0-9_])/", "", $cookie_lang );
$get_lang = getparam ( "lang", PAR_GET, SAN_HTML );
$get_lang = preg_replace ( "/([^A-Za-z0-9_])/", "", $get_lang );
//lingua----<


//tema---->
$cookie_theme = getparam ( "theme", PAR_COOKIE, SAN_HTML );
$get_theme = getparam ( "theme", PAR_GET, SAN_HTML );
$get_testtheme = getparam ( "testtheme", PAR_GET, SAN_HTML );
$get_cc_theme = getparam ( "cc_theme", PAR_GET, SAN_HTML );
$cookie_cc_theme = getparam ( "cc_theme", PAR_COOKIE, SAN_HTML );
$cookie_theme = preg_replace ( "/([^A-Za-z0-9_])/", "", $cookie_theme );
$get_theme = preg_replace ( "/([^A-Za-z0-9_])/", "", $get_theme );
$get_testtheme = preg_replace ( "/([^A-Za-z0-9_])/", "", $get_testtheme );
$get_cc_theme = preg_replace ( "/([^A-Za-z0-9_])/", "", $get_cc_theme );
$cookie_cc_theme = preg_replace ( "/([^A-Za-z0-9_])/", "", $cookie_cc_theme );
//dprint_r($get_theme);
//tema----<
$cookie_showaccesskey = getparam ( "showaccesskey", PAR_COOKIE, SAN_PARA );
$get_showaccesskey = getparam ( "showaccesskey", PAR_GET, SAN_PARA );
$get_fneditmode = getparam ( "fneditmode", PAR_GET, SAN_PARA );
$cookie_fneditmode = getparam ( "fneditmode", PAR_COOKIE, SAN_PARA );

if ($cookie_session != "" && strpos ( $cookie_lang, ".." ) === false)
{
	$session = $cookie_session;
}
else
{
	$session = microtime ();
	setcookie ( "session", $session, $time, $urlcookie );
}

if ($cookie_lang != "" && strpos ( $cookie_lang, ".." ) === false && strpos ( $languages, $cookie_lang ) !== false)
{
	$lang = $cookie_lang;
}

if ($get_lang != "" && strpos ( $get_lang, ".." ) === false && (strpos ( $languages, $get_lang ) !== false || $get_lang == 'auto'))
{
	$lang = $get_lang;
	setcookie ( "lang", $get_lang, $time, $urlcookie );
}
// imposta la lingua in automatico
if ($lang == 'auto')
{
	$find = false;
	$languages_br_str = getparam ( 'HTTP_ACCEPT_LANGUAGE', PAR_SERVER, SAN_FLAT );
	$languages_br = split ( ",", $languages_br_str );
	
	$llangs = explode ( ",", $languages );
	
	for($index = 0; $index < sizeof ( $languages_br ); $index ++)
	{
		$tmplang = $languages_br [$index];
		if (in_array ( $tmplang, $llangs ))
		{
			$lang = $tmplang;
		}
	}
}
// theme --------------------->
if ($cookie_theme != "" && file_exists ( "themes/" . $cookie_theme . "/theme.php" ))
{
	$theme = $cookie_theme;
}
if ($get_theme != "" && file_exists ( "themes/" . $get_theme . "/theme.php" ))
{
	$theme = $get_theme;
	setcookie ( "theme", $get_theme, $time, $urlcookie );
}
if ($get_testtheme != "" && file_exists ( "themes/" . $get_testtheme . "/theme.php" ))
{
	$theme = $get_testtheme;
}

// theme ---------------------<
// cc_theme --------------------->
if ($cookie_cc_theme != "" && file_exists ( "themes/" . $cookie_cc_theme . "/theme.php" ))
{
	$cc_theme = $cookie_cc_theme;
}
if ($get_cc_theme != "" && file_exists ( "themes/" . $get_cc_theme . "/theme.php" ))
{
	$cc_theme = $get_cc_theme;
	setcookie ( "cc_theme", $get_cc_theme, $time, $urlcookie );
}

if (basename ( $_SERVER ['SCRIPT_FILENAME'] ) == "controlcenter.php")
{
	$theme = $cc_theme;
}
// cc_theme ---------------------<


// accesskey --------------------->
if ($cookie_showaccesskey != "")
{
	$showaccesskey = $cookie_showaccesskey;
}
if ($get_showaccesskey != "")
{
	$showaccesskey = $get_showaccesskey;
	setcookie ( "showaccesskey", $get_showaccesskey, $time, $urlcookie );
}
// accesskey ---------------------<
// fneditmode -------------------->
if ($cookie_fneditmode != "")
{
	$_FN ['fneditmode'] = $cookie_fneditmode;
}
if ($get_fneditmode != "")
{
	$_FN ['fneditmode'] = $get_fneditmode;
	setcookie ( "fneditmode", $get_fneditmode, $time, $urlcookie );
}
// fneditmode --------------------<


//da config


$_FN ['sitename'] = $sitename;
$_FN ['sitetitle'] = $sitename;
$_FN ['keywords'] = $keywords;
if (!file_exists("themes/$theme"))
	$theme="base";

$_FN ['theme'] = $theme;
$_FN ['cc_theme'] = $cc_theme;
$_FN ['admin'] = $admin;
$_FN ['admin_mail'] = $admin_mail;
$_FN ['lang'] = $lang;
$_FN ['siteurl'] = $siteurl;
$_FN ['jet_lag'] = $jet_lag;
$_FN ['listlanguages'] = explode ( ",", $languages );
foreach ( $_FN ['listlanguages'] as $k => $v )
{
	$_FN ['listlanguages'] [$k] = trim ( ltrim ( $v ) );
}
//$_FN['langs'] = $_FN['listlanguages'];
$_FN ['languages'] = $languages;
$_FN ['lang_auto_switch'] = $lang_auto_switch;
$_FN ['htmleditor'] = $htmleditor;
$_FN ['registration_by_email'] = $registration_by_email;
$_FN ['enable_log_email'] = $enable_log_email;
$_FN ['log_email_address'] = $log_email_address;
$_FN ['site_email_address'] = $site_email_address;
$_FN ['home_section'] = $home_section;
$_FN ['show_welcome_message'] = $show_welcome_message;
$_FN ['showaccesskey'] = $showaccesskey;
$_FN ['maintenance'] = $maintenance;
$_FN ['remember_login'] = $remember_login;
$_FN ['syntax_highlighting'] = $syntax_highlighting;
$_FN ['datadir'] = $fn_datadir;
$_FN ['enable_registration'] = $enable_registration;
$_FN ['enable_mod_rewrite'] = isset ( $enable_mod_rewrite ) ? $enable_mod_rewrite : 0;
$_FN ['enable_compress_gzip'] = isset ( $enable_compress_gzip ) ? $enable_compress_gzip : 0;
if (!isset($_SERVER['HTTP_ACCEPT_ENCODING']) || !strstr($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip'))
{
	$_FN ['enable_compress_gzip'] =	0;
}



$_FN ['enable_online_administration'] = isset ( $enable_online_administration ) ? $enable_online_administration : 1;
if (!$_FN ['enable_online_administration'])
	$_FN ['fneditmode'] = false;

$_FN ['mod'] = getparam ( "mod", PAR_GET, SAN_FLAT );
$_FN ['vmod'] = find_section ( $_FN ['mod'] );
if ($_FN ['vmod'] == "")
	$_FN ['vmod'] = find_section ( $_FN ['home_section'] );
$_FN ['idmod'] = get_section_id ( $_FN ['vmod'] );

if (! isset ( $_FN ['close_tag'] ))
	$_FN ['close_tag'] = "";

$_FN ['session'] = $session;

?>