<?php
/**
 * flatnux.php Created on 14/dic/07
 *
 * Main file to include to get all the functionality of FlatNuX
 * 
 * @package Flatnux
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */

ini_set("display_errors","off");
ini_set("upload_max_filesize","20M");
error_reporting(E_ALL);
ob_start();
date_default_timezone_set("UTC");
global $_FN;
$_FN = array();
$mtime = microtime();
$mtime = explode(" ",$mtime);
$mtime = doubleval($mtime[1]) + doubleval($mtime[0]);
$_FN['timestart'] = $mtime; // tempo inizio script
/**
 * Turn register globals off.
 *
 * @return null Will return null if register_globals PHP directive was disabled
 */
function fn_unregister_GLOBALS()
{
	if (  !ini_get('register_globals') )
		return;
	if ( isset($_REQUEST['GLOBALS']) )
		die('GLOBALS overwrite attempt detected');
		// Variables that shouldn't be unset
	$noUnset = array('GLOBALS','_GET','_POST','_COOKIE','_REQUEST','_SERVER','_ENV','_FILES','table_prefix');
	$input = array_merge($_GET,$_POST,$_COOKIE,$_SERVER,$_ENV,$_FILES,isset($_SESSION) && is_array($_SESSION) ? $_SESSION : array());
	foreach ( $input as $k=>$v )
		if (  !in_array($k,$noUnset) && isset($GLOBALS[$k]) )
		{
			$GLOBALS[$k] = NULL;
			unset($GLOBALS[$k]);
		}
}
fn_unregister_GLOBALS();
//-------------------COMUNI PER I FILES SULLA ROOT -------------------------->
//ripristino la posizione reale --->
$old = false;
while ( !file_exists("include/flatnux.php"))
{
	$d = dir(realpath("."));
	if (  !chdir("..") || $old == $d->path )
		die("flatnux not found");
	$old = $d->path;
}

//ripristino la posizione reale ---<
require_once "include/functions.php";

//-----config.php------>
global $sitename,$keywords,$theme,$admin,$admin_mail;
global $lang,$siteurl,$jet_lag,$languages,$lang_auto_switch;
global $htmleditor,$registration_by_email,$enable_log_email,$log_email_address,$site_email_address;
global $home_section,$show_welcome_message,$showaccesskey,$maintenance,$remember_login;
global $syntax_highlighting,$fn_datadir,$enable_registration,$enable_mod_rewrite,$enable_account_deletion;
global $cc_theme;
//-----config.php------<
if ( file_exists('config.php') )
	include "config.php";
else
{
	include "include/config.install.php";
}

include ("include/auth/" . _AUTH . ".php");
//----LOGIN/LOGOUT--------------->
$fnlogin = getparam("fnlogin",PAR_GET,SAN_FLAT);
$fnuser = getparam("username",PAR_POST,SAN_FLAT);
$fnpwd = getparam("password",PAR_POST,SAN_FLAT);
if ( $fnlogin == "login" && $fnuser != "" && $fnpwd != "" )
{
	if ( fn_verify_user_password($fnuser,$fnpwd) )
	{
		
		fn_login($fnuser);
	}
	else
	{
		$_FN['login_error'] = "error username or password";
	}
}


if ( $fnlogin == "logout" )
	fn_logout($fnuser);
//----LOGIN/LOGOUT---------------<	
//-----------language----------------------------->
global $mesi,$giorni;
if ( file_exists("languages/" . $_FN['lang'] . ".php") )
{
	include_once ("languages/" . $_FN['lang'] . ".php");
}
else
	include_once ("languages/en.php");
if ( file_exists("sections/" . $_FN['vmod'] . "/lang." . $_FN['lang'] . ".php") )
{
	include_once ("sections/" . $_FN['vmod'] . "/lang." . $_FN['lang'] . ".php");
}
else 
	if ( file_exists("sections/" . $_FN['vmod'] . "/lang.en.php") )
		include_once ("sections/" . $_FN['vmod'] . "/lang.en.php");
	//-----------language-----------------------------<
// verifica utente---->
$_FN['user'] = getparam("myforum",PAR_COOKIE,SAN_FLAT);
if ( $_FN['user'] != "" &&  !versecid($_FN['user']) )
	fn_logout();
	// verifica utente----<
global $_FNUSER,$_FNMOD,$_FNVMOD,$fn_datadir;
$fn_datadir = &$_FN['datadir'];
$_FNUSER = & $_FN['user'];
$_FNMOD = & $_FN['mod'];
$_FNVMOD = & $_FN['vmod'];
//per compatibilita' con temi flatnuke ----->
global $time1;
$time1 = &$_FN['timestart'];
//per retrocompatibilita' rendo globali le variabili del config.
foreach ( $_FN as $key=>$value )
{
	eval('global $_FN,$' . $key . ';' . '$' . $key . '=&$_FN["' . $key . '"];');
}
//per compatibilita' con temi flatnuke -----<
include_once "./include/theme.php";
//-------------------COMUNI PER I FILES SULLA ROOT --------------------------<
function fn_include($filename)
{
	return include ($filename);
}
function fn_require($filename)
{
	return require ($filename);
}
function fn_include_once($filename)
{
	return include_once ($filename);
}
function fn_require_once($filename)
{
	return require_once ($filename);
}
function fn_is_external_referer()
{
	global $_FN;
	$refererfrom = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : "";
	if ( $refererfrom == "" ||  !fn_erg($_FN['siteurl'],"$refererfrom") )
	{
		return true;
	}
	return false;
}

?>