<?php
/**
 * Flatnux xmldb functions
 * 
 * @package Flatnux_functions
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
/**
 * 
 * @param $tablename
 * @param $xmldatabase
 * @param $params
 */
function FN_xmltableeditor($tablename, $xmldatabase, $params = false)
{
	global $_FN;
	$op = getparam("opt", PAR_GET, SAN_HTML);
	$link = "mod={$_FN['mod']}&amp;opt=$op";
	$params['path'] = $_FN['datadir'];
	$params['lang'] = $_FN['lang'];
	$params['languages'] = $_FN['languages'];
	if ( !isset($params['link']) )
		$params['link'] = $link;
	//messages--->
	$params['path'] = isset($params['path']) ? $params['path'] : $_FN['datadir'];
	$params['recordsperpage'] = isset($params['recordsperpage']) ? $params['recordsperpage'] : 20;
	$params['textview'] = isset($params['textview'])?$params['textview'] :fn_i18n("_VIEW");
	$params['textmodify'] = isset($params['textmodify'])?$params['textmodify'] :fn_i18n("_MODIFICA");
	$params['textdelete'] = isset($params['textdelete'])?$params['textdelete'] :fn_i18n("_ELIMINA");
	$params['textviewlist'] = isset($params['textviewlist'])?$params['textviewlist'] : "<img style=\"vertical-align:middle;border:0px;\" alt=\"\"  src=\"" . fromtheme("images/icons/back.png") . "\" />&nbsp;".fn_i18n("_INDIETRO");
	$params['textinsertok'] = isset($params['textinsertok'])?$params['textinsertok'] :fn_i18n("The_data_were_successfully_inserted");
	$params['textupdateok'] = isset($params['textupdateok'])?$params['textupdateok'] :fn_i18n("The_data_were_successfully_updated");
	$params['textpages'] = isset($params['textpages'])?$params['textpages'] :fn_i18n("_FNPAG"). ":";
	$params['textrequired'] = isset($params['textrequired'])?$params['textrequired'] :"*";
	$params['textfields'] = isset($params['textfields'])?$params['textfields'] :fn_i18n("_FCAMPI");
	$params['textcancel'] = isset($params['textcancel'])?$params['textcancel'] :fn_i18n("_CANCEL");
	$params['textnew'] = isset($params['textnew'])?$params['textnew'] : "<img style=\"vertical-align:middle;border:0px;\" alt=\"\"  src=\"" . fromtheme("images/add.png") . "\" />[".fn_i18n("_NEW")."]";

	//messages---<

	XMLDB_editor($tablename, $xmldatabase, $params);
}
/**
 * mostra editor html nella xmldb
 *
 * @param string $name
 * @param string $value
 * @param string $rows
 * @param string $cols
 * @param string $tooltip
 */
function xmldbform_print_field_html_overwrite($name, $value, $rows, $cols, $tooltip)
{
	global $_FN;
	$editor = $_FN['htmleditor'];
	if ( isset($_FN['force_htmleditor']) && $_FN['force_htmleditor'] != "" )
	{
		$editor = $_FN['force_htmleditor'];
	}
	if ( $editor != "0" && file_exists("include/extra/" . $editor . "/htmlarea.php") )
	{
		require_once ("include/extra/" . $editor . "/htmlarea.php");
		$defaultdir = false;
		if ( isset($_FN['editor_folder']) )
		{
			$defaultdir = $_FN['editor_folder'];
		}
		showhtmlarea($name, $cols, $rows, $value, $defaultdir);
	}
	else
	{
		echo "<textarea title=\"$tooltip\" cols=\"" . $cols . "\"  rows=\"" . $rows . "\"  name=\"$name\"  >";
		echo htmlspecialchars($value);
		echo "</textarea>";
	}
}
//---------datetime-------------------------------------------->
class xmldbform_field_datetime
{
	function xmldbform_field_datetime()
	{

	}
	function show($params)
	{
		global $giorni, $mesi;
		echo "<script language=\"javascript\">
Calendar._DN = new Array
  (
";
		$v = "";
		foreach ( $giorni as $g )
		{
			echo "\n$v\"$g\"";
			$v = ",";
		}
		echo "\n,\"" . $giorni[0] . "\"";
		echo "
);
</script>";
		echo "<script language=\"javascript\">
Calendar._MN = new Array
(
";
		$v = "";
		foreach ( $mesi as $g )
		{
			echo "\n$v\"$g\"";
			$v = ",";
		}
		echo ");


Calendar._TT = {};
Calendar._TT[\"TOGGLE\"] = \"Toggle first day of week\";
Calendar._TT[\"PREV_YEAR\"] = \"Prev. year (hold for menu)\";
Calendar._TT[\"PREV_MONTH\"] = \"Prev. month (hold for menu)\";
Calendar._TT[\"GO_TODAY\"] = \"Go Today\";
Calendar._TT[\"NEXT_MONTH\"] = \"Next month (hold for menu)\";
Calendar._TT[\"NEXT_YEAR\"] = \"Next year (hold for menu)\";
Calendar._TT[\"SEL_DATE\"] = \"Select date\";
Calendar._TT[\"DRAG_TO_MOVE\"] = \"Drag to move\";
Calendar._TT[\"PART_TODAY\"] = \" (today)\";
Calendar._TT[\"MON_FIRST\"] = \"Display Monday first\";
Calendar._TT[\"SUN_FIRST\"] = \"Display Sunday first\";
Calendar._TT[\"CLOSE\"] = \"Close\";
Calendar._TT[\"TODAY\"] = \"Today\";

</script>";
		$this->starttagtitle = isset($params['frm_starttagtitle']) ? $params['frm_starttagtitle'] : "<tr><td  valign=\"top\" >";
		$this->endtagtitle = isset($params['frm_endtagtitle']) ? $params['frm_endtagtitle'] : "</td>";
		$this->starttagvalue = isset($params['frm_starttagvalue']) ? $params['frm_starttagvalue'] : "<td valign=\"top\" >";
		$this->endtagvalue = isset($params['frm_endtagvalue']) ? $params['frm_endtagvalue'] : "</td></tr>";
		$toltips = ($params['frm_help'] != "") ? "title=\"" . $params['frm_help'] . "\"" : "";
		$strhiddenfield = $params['strhiddenfield'];
		$dateformat = "y-mm-dd 00:00:00";
		if ( isset($params['frm_dateformat']) && $params['frm_dateformat'] != "" )
			$dateformat = $params['frm_dateformat'];
		//$size = isset ( $params ['frm_size'] ) ? $params ['frm_size'] : 20;
		//$oldval = $params ['value'];
		echo $this->starttagtitle . $params['title'] . $this->endtagtitle;
		echo $this->starttagvalue;
		echo "\n$strhiddenfield ";
		echo "<input onclick=\"return showCalendar('xmldb_bcalendar_" . $params['name'] . "', '$dateformat');\" $toltips name=\"" . $params['name'] . "\" id=\"xmldb_bcalendar_" . $params['name'] . "\" value=\"" . $params['value'] . "\" /><input onclick=\"return showCalendar('xmldb_bcalendar_" . $params['name'] . "', '$dateformat');\" type=\"button\" value=\"...\" />";
		echo $this->endtagvalue;
	}
}
//---------datetime--------------------------------------------<
//---------ux_radio-------------------------------------------->
//  esempio:
//	<field>
//		<name>sex</name>
//		<frm_it>Sesso</frm_it>
//		<frm_en>Sex</frm_en>
//		<frm_type>radio</frm_type>
//		<frm_options>M,F</frm_options>
//		<frm_options_it>Maschio,Femmina</frm_options_it>
//		<frm_options_en>Male,Female</frm_options_en>
//	</field>
/**
 * 
 * @author alessandro
 *
 */
class xmldbform_field_radio
{
	function xmldbform_field_radio()
	{

	}
	function show($params)
	{
		$this->starttagtitle = isset($params['frm_starttagtitle']) ? $params['frm_starttagtitle'] : "<tr><td  valign=\"top\" >";
		$this->endtagtitle = isset($params['frm_endtagtitle']) ? $params['frm_endtagtitle'] : "</td>";
		$this->starttagvalue = isset($params['frm_starttagvalue']) ? $params['frm_starttagvalue'] : "<td valign=\"top\" >";
		$this->endtagvalue = isset($params['frm_endtagvalue']) ? $params['frm_endtagvalue'] : "</td></tr>";
		$strhiddenfield = $params['strhiddenfield'];
		/*
		  $languagesfield = $params ['languagesfield'];
		  $lang_noprefix = $params ['lang_noprefix'];
		  $oldvalues = $params ['oldvalues'];
		 */
		$tooltip = $params['frm_help'];
		echo $this->starttagtitle . $params['title'] . $this->endtagtitle;
		echo $this->starttagvalue;
		echo "\n$strhiddenfield";
		$name = $params['name'];
		$value = $params['value'];
		//dprint_r($params['value']);
		$options = explode(",", $params['frm_options']);
		$optionslang = array();
		if ( isset($params['frm_options_' . $params['lang']]) )
			$optionslang = explode(",", $params['frm_options_' . $params['lang']]);
		$i = 0;
		$toenable = $todisable = "";
		if ( isset($params['frm_options_enable']) )
		{
			$toenable = explode(",", $params['frm_options_enable']);
		}
		if ( isset($params['frm_options_disable']) )
		{
			$todisable = explode(",", $params['frm_options_disable']);
		}
		//dprint_r($todisable);
		$jexecute = "";
		foreach ( $options as $k => $option )
		{
			$jsonclick = $js = "";
			if ( is_array($toenable) && isset($toenable[$k]) )
			{
				$enableitems = explode("|", $toenable[$k]);
				foreach ( $enableitems as $it )
				{
					$js .= "if(document.getElementsByName('$it')[0]!=undefined)document.getElementsByName('$it')[0].disabled=false;";
				}
			}
			if ( is_array($todisable) && isset($todisable[$k]) )
			{
				$disableitems = explode("|", $todisable[$k]);
				foreach ( $disableitems as $it )
				{
					$js .= "if(document.getElementsByName('$it')[0]!=undefined)document.getElementsByName('$it')[0].disabled=true;";
				}
			}
			if ( $value === $option )
			{
				$jexecute .= $js;
			}
			if ( $js != "" )
			{
				$jsonclick = "onclick=\"$js\"";
			}
			$sel = "";
			$toption = $option;
			if ( isset($optionslang[$i]) && $optionslang[$i] != "" )
				$toption = $optionslang[$i];
			if ( $value === $option )
				$sel = "checked=\"checked\"";
			//dprint_r("$value == $option");
			echo "&nbsp;<nobr>$toption<input $sel $jsonclick type=\"radio\" value=\"$option\" title=\"$tooltip\" name=\"" . $name . "\"  /></nobr>";
			$i++;
		}
		//dovrebbe caricarlo alla fine
		//$jexecute="while(document.);".";$jexecute";
		echo ("<script language=\"javascript\" >setTimeout(\"$jexecute\",0);</script>");
		echo $this->endtagvalue;
	}
}
//---------ux_radio--------------------------------------------<
//---------ux_conditions--------------------------------------->
/**
 * 
 * @author alessandro
 *
 */
class xmldbform_field_conditions_check
{
	function xmldbform_field_conditions_check()
	{

	}
	function show($params)
	{
		global $_FN;
		$this->starttagtitle = isset($params['frm_starttagtitle']) ? $params['frm_starttagtitle'] : "<tr><td  valign=\"top\" >";
		$this->endtagtitle = isset($params['frm_endtagtitle']) ? $params['frm_endtagtitle'] : "</td>";
		$this->starttagvalue = isset($params['frm_starttagvalue']) ? $params['frm_starttagvalue'] : "<td valign=\"top\" >";
		$this->endtagvalue = isset($params['frm_endtagvalue']) ? $params['frm_endtagvalue'] : "</td></tr>";
		$lang_user = $_FN['lang'];
		$file_conditions = $_FN['datadir'] . "/conditions.$lang_user.html";
		if ( !file_exists($file_conditions) )
		{
			$fp = fopen($file_conditions, "w");
			fwrite($fp, fn_i18n("_REG_AGREEMENT_TERMS"));
			fclose($fp);
		}
		$toltips = "";
		$strhiddenfield = $params['strhiddenfield'];
		$oldval = $params['value'];
		echo $this->starttagtitle . $params['title'] . $this->endtagtitle;
		echo $this->starttagvalue;
		$ch = "";
		if ( $oldval != "" )
			$ch = "checked=\"checked\"";
		if ( $oldval != "yes" )
		{
			$ch = "";
		}
		echo "\n$strhiddenfield ";
		echo "<input type=\"hidden\" value=\"" . htmlspecialchars($oldval) . "\" name=\"__check__" . $params['name'] . "\"  />";
		echo "<div style=\"border:1px inset;overflow:auto;height:100px;width:100%;\" >";
		echo file_get_contents($file_conditions);
		echo "</div>";
		echo "<input name=\"" . $params['name'] . "\" type=\"hidden\" value=\"no\" />";
		echo "<br />" . fn_i18n("_REG_IACCEPT") . "&nbsp;<input style=\"vertical-align:middle\" $toltips $ch type=\"checkbox\" value=\"yes\" name=\"" . $params['name'] . "\"  />";
		echo $this->endtagvalue;
	}
}
/**
 * contitions field validator
 * @param $value
 * @return misc true or error message
 */
function fn_accept_condition_validator($value)
{
	if ( $value != "yes" )
	{
		return fn_i18n("_REG_CONDITIONSACCEPT");
	}
	else
		return true;
}
//---------ux_conditions---------------------------------------<
//---------localfile--------------------------------------->
/**
 * 
 * @author alessandro
 *
 */
class xmldbform_field_localfile
{
	function xmldbform_field_localfile()
	{

	}
	function show($params)
	{
		global $_FN;
		$this->starttagtitle = isset($params['frm_starttagtitle']) ? $params['frm_starttagtitle'] : "<tr><td  valign=\"top\" >";
		$this->endtagtitle = isset($params['frm_endtagtitle']) ? $params['frm_endtagtitle'] : "</td>";
		$this->starttagvalue = isset($params['frm_starttagvalue']) ? $params['frm_starttagvalue'] : "<td valign=\"top\" >";
		$this->endtagvalue = isset($params['frm_endtagvalue']) ? $params['frm_endtagvalue'] : "</td></tr>";
		$fmpath = isset($params['frm_path']) ? $params['frm_path'] : "{$_FN['datadir']}";
		$mime = isset($params['frm_mime']) ? "mime={$params['frm_mime']}&" : "";
		$toltips = ($params['frm_help'] != "") ? "title=\"" . $params['frm_help'] . "\"" : "";
		$strhiddenfield = $params['strhiddenfield'];
		$size = isset($params['frm_size']) ? $params['frm_size'] : 30;
		echo $this->starttagtitle . $params['title'] . $this->endtagtitle;
		echo $this->starttagvalue;
		echo $strhiddenfield;
		//-----------------------------------------
		$languagesfield = $params['languagesfield'];
		$lang_noprefix = $params['lang_noprefix'];
		$idop = "localfile{$params['name']}";
		$oldvalues = $params['oldvalues'];
		echo "<input $toltips size=\"" . $size . "\" name=\"{$params['name']}\" id=\"$idop\" value=\"" . str_replace('"', '&quot;', $params['value']) . "\" />";
		$onclick = "window.open('filemanager.php?{$mime}dir={$fmpath}&local=1&mode=t&filemanager_editor=local&opener=$idop','filemanager','toolbar= 0,location= 0,directories= 0,status= 0,menubar= 0,scrollbars= 1,resizable= 1,width=640,height=480');return false;";
		echo "<button onclick=\"$onclick\">" . fn_i18n("_CERCA") . "</button>";
		//-----------------------------------------
		echo $this->endtagvalue;
	}
}
/**
 * convert time in date 
 * @param int $time
 */
function xmldb_get_datefield($time)
{
	$dateformat = "Y-m-d H:i:s";
	$date = time();
	$date = date($dateformat);
	return $date;
}
?>