<?php
/**
 * @package flatnux_section_download
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
while ( ! file_exists ( "include/flatnux.php" ) )
{
	chdir ( ".." );
}
global $_FN;
include_once "./include/flatnux.php";

$file = strippostpslashes ( getparam ( "f", PAR_GET, SAN_FLAT ) );
if (stristr ( $file, ".." ))
	die ( _NONPUOI );
	
//dprint_r($_FN);

$fields = array();
// se il file non esiste lo crea
if (! file_exists ( $_FN ['datadir'] . "/fndatabase/download.php" ))
{
	$fields [1] ['name'] = "filename";
	$fields [1] ['primarykey'] = "1";
	$fields [2] ['name'] = "numdownload";
	$fields [2] ['defaultvalue'] = "0";
	createxmltable ( "fndatabase", "download", $fields, $_FN ['datadir'], "download" );
}

$stat = new XMLTable ( "fndatabase", "download", $_FN ['datadir'] );
$oldval = $stat->GetRecordByPrimaryKey ( $file );
$r ['filename'] = $file;
if ($oldval == null)
{
	$r ['numdownload'] = 1;
	$t = $stat->InsertRecord ( $r );
}
else
{
	//incrementa download
	$r ['numdownload'] = $oldval ['numdownload'] + 1;
	$t = $stat->UpdateRecord ( $r );
}
//dprint_r($t);
//die("x");


if (get_file_extension ( $file ) == "link")
{
	header ( "Location: " . file_get_contents ( $_FN ['datadir'] . "/Download/$file" ) );
}
else
	FN_dl_file ( $_FN ['datadir'] . "/Download/$file" );

function FN_dl_file($file)
{
	
	//First, see if the file exists
	if (! is_file ( $file ))
	{
		die ( "<b>$file 404 File not found!</b>" );
	}
	
	//Gather relevent info about file
	$len = filesize ( $file );
	$filename = basename ( $file );
	$file_extension = strtolower ( substr ( strrchr ( $filename, "." ), 1 ) );
	
	//This will set the Content-Type to the appropriate setting for the file
	switch ($file_extension)
	{
		case "pdf" :
			$ctype = "application/pdf";
			break;
		case "exe" :
			$ctype = "application/octet-stream";
			break;
		case "zip" :
			$ctype = "application/zip";
			break;
		case "doc" :
			$ctype = "application/msword";
			break;
		case "xls" :
			$ctype = "application/vnd.ms-excel";
			break;
		case "ppt" :
			$ctype = "application/vnd.ms-powerpoint";
			break;
		case "gif" :
			$ctype = "image/gif";
			break;
		case "png" :
			$ctype = "image/png";
			break;
		case "jpeg" :
		case "jpg" :
			$ctype = "image/jpg";
			break;
		case "mp3" :
			$ctype = "audio/mpeg";
			break;
		case "wav" :
			$ctype = "audio/x-wav";
			break;
		case "mpeg" :
		case "mpg" :
		case "mpe" :
			$ctype = "video/mpeg";
			break;
		case "mov" :
			$ctype = "video/quicktime";
			break;
		case "avi" :
			$ctype = "video/x-msvideo";
			break;
		
		//The following are for extensions that shouldn't be downloaded (sensitive stuff, like php files)
		case "php" :
		case "htm" :
		case "html" :
		case "txt" :
			@readfile ( $file );
			
			return;
			break;
		
		default :
			$ctype = "application/force-download";
	}
	
	//Begin writing headers
	header ( "Pragma: public" );
	header ( "Expires: 0" );
	header ( "Cache-Control: must-revalidate, post-check=0, pre-check=0" );
	header ( "Cache-Control: public" );
	header ( "Content-Description: File Transfer" );
	
	//Use the switch-generated Content-Type
	header ( "Content-Type: $ctype" );
	
	//Force the download
	$header = "Content-Disposition: attachment; filename=" . $filename . ";";
	header ( $header );
	header ( "Content-Transfer-Encoding: binary" );
	header ( "Content-Length: " . $len );
	@readfile ( $file );
	exit ();
}

?>