<?php
/**
 * @package flatnux_section_files
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 * 
 */
/**
 * securehtml
 * Ripulisce l' html da codici "maliziosi"
 *
 *
 * @param string testo
 * */
function securehtml($text, $blacklist = "script,iframe,frame,object,embed")
{
	$blacklist = explode(",", $blacklist);
	$ok = false;
	//deve fare un giro completo senza che ci sia nessun tag in blacklist nella stringa
	while ( $ok == false )
	{
		$ok = true;
		foreach ( $blacklist as $itemtag )
		{
			while ( preg_match("/<{$itemtag}.*?>/is", $text) )
			{
				$ok = false;
				$text = preg_replace("/<{$itemtag}.*>/is", "", $text);
				$text = preg_replace("/<\\/{$itemtag}.*?>/is", "", $text);
			}
		}
	}
	//dprint_xml($text);
	return fnfiles_strip_javascript($text);
}

function fnfiles_strip_javascript($filter){

    // realign javascript href to onclick
    $filter = preg_replace("/href=(['\"]).*?javascript:(.*)?\\1/i", "onclick=' $2 '", $filter);

    //remove javascript from tags
    while( preg_match("/<(.*)?javascript.*?\(.*?((?>[^()]+)|(?R)).*?\)?\)(.*)?>/i", $filter))
        $filter = preg_replace("/<(.*)?javascript.*?\(.*?((?>[^()]+)|(?R)).*?\)?\)(.*)?>/i", "<$1$3$4$5>", $filter);

    while( preg_match("/<(.*)?:expr.*?\(.*?((?>[^()]+)|(?R)).*?\)?\)(.*)?>/i", $filter))
        $filter = preg_replace("/<(.*)?:expr.*?\(.*?((?>[^()]+)|(?R)).*?\)?\)(.*)?>/i", "<$1$3$4$5>", $filter);

    // remove all on* events
    while( preg_match("/<(.*)?\s?on.+?=?\s?.+?(['\"]).*?\\2\s?(.*)?>/i", $filter) )
       $filter = preg_replace("/<(.*)?\s?on.+?=?\s?.+?(['\"]).*?\\2\s?(.*)?>/i", "<$1$3>", $filter);
    return $filter;
}

/**
 * Permette di scaricare un file dalle sezione "Download" gestendone
 * il conteggio dei downloads.
 *
 * @author Simone Vellei <simone_vellei@users.sourceforge.net>
 *
 * @param string $file Nome assoluto del file da scaricare
 */
function go_download($file)
{
	global $_FN;
	global $databasename, $tablename, $pathdatabase;
	// evita di accedere a directory esterne
	if ( stristr($file, "..") )
		die(fn_i18n("_NONPUOI"));
	// se il file non esiste lo crea
	if ( !file_exists("$pathdatabase/$databasename/$tablename" . "_download_stat") || !file_exists("$pathdatabase/$databasename/$tablename" . "_stat.php") )
	{
		//echo "<br>creazione statistiche $tablename";
		$sfields = array();
		$sfields[1]['name'] = "filename";
		$sfields[1]['primarykey'] = "1";
		$sfields[2]['name'] = "numdownload";
		$sfields[2]['defaultvalue'] = "0";
		echo createxmltable($databasename, $tablename . "_download_stat", $sfields, $pathdatabase);
	}
	$stat = new XMLTable($databasename, $tablename . "_download_stat", $_FN['datadir']);
	$oldval = $stat->GetRecordByPrimaryKey($file);
	$r['filename'] = $file;
	if ( $oldval == null )
	{
		$r['numdownload'] = 1;
		$stat->InsertRecord($r);
	}
	else
	{
		//incrementa download
		$r['numdownload'] = $oldval['numdownload'] + 1;
		$stat->UpdateRecord($r);
	}
	Header("Location:$pathdatabase/$databasename/$tablename/$file");
}
/**
 * writecomment
 * aggiunge un commento al record
 * 
 * @param string unirecid record
 */
function writecomment($unirecid)
{
	global $_FN, $tableborder, $viewpageback, $enablecomments;
	global $tablename, $databasename, $recordsperpage, $pathdatabase;
	$tablelinks = new FieldForm("$databasename", "$tablename" . "_comments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	if ( isset($_POST['comment']) )
	{
		$newvalues = $tablelinks->getbypost();
		$newvalues['comment'] = htmlspecialchars($newvalues['comment']);
		$newvalues['unirecidrecord'] = $unirecid;
		$newvalues['username'] = $_FN['user'];
		$newvalues['insert'] = time();
		$err = $tablelinks->Verify($newvalues);
		if ( $err != "" )
		{
			echo fn_i18n("_FERRCAMPO") . ":<br /><br />";
			echo $err . "<br />";
			$tit = fn_i18n("_INDIETRO");
			echo "<a accesskey=" . getaccesskey($tit, "javascript:history.back()") . " href=\"javascript:history.back()\">&lt;&lt;$tit</a><br /><br />";
		}
		else
		{
			$tablelinks->xmltable->InsertRecord($newvalues);
			echo fn_i18n("_FMESSOK") . "<br />";

			$Table = new FieldForm($databasename, $tablename, $pathdatabase, $_FN['lang'], $_FN['languages']);
			$newvalues = $Table->xmltable->GetRecordByPrimaryKey($unirecid);
			$newvalues['update'] = time();
			$Table->xmltable->UpdateRecord($newvalues);
			viewrecordpage($unirecid,$Table);
			FN_log("Comment added: table $tablename, record $unirecid");
		}
	}
	else
	{
		if ( $_FN['user'] != "" && $unirecid != "" )
		{
			echo "<br />";
			echo "\n<form method=\"post\" enctype=\"multipart/form-data\" action=\"index.php?mod={$_FN['mod']}&id=$unirecid&op=writecomment\" >";
			echo "\n<table>";
			echo "\n<tr><td colspan=\"2\"><b>" . fn_i18n("_FP_ADDCOMM") . "</b></tr></td>";
			echo "\n<tr><td colspan=\"2\">" . fn_i18n("_FCAMPI") . "</tr></td>";
			echo "\n<tr><td colspan=\"2\">";
			bbcodes_panel("comment", "formatting");
			bbcodes_panel("comment", "emoticons");
			bbcodes_js();
			echo "\n</td></tr>";
			echo "<tr><td>";
			$tablelinks->setlayoutTags("<b>", ":</b><div>", "</div>", "<br /><br />");
			$tablelinks->ShowInsertForm();
			echo "</td></tr>";
			echo "\n<tr><td colspan=\"2\"><input class=\"submit\" type=\"submit\" value=\"" . fn_i18n("_SAVE") . "\"/>";
			echo "<input type='button' class='button' onclick='window.location=(\"index.php?mod={$_FN['mod']}\")'  value='" . fn_i18n("_CANCEL") . "' />";
			echo "</tr></td>";
			echo "\n";
			echo "\n</table>";
			echo "\n</form>";
		}
	}
	viewcomments($unirecid);
}
/**
 * viewcomments
 * visualizza i commenti associati al record
 * 
 * @param string unirecid record
 */
function viewcomments($unirecid)
{
	global $_FN, $_FN, $tableborder, $viewpageback;
	global $tablename, $databasename, $recordsperpage, $pathdatabase, $enablecomments;
	$tablelinks = new FieldForm("$databasename", "$tablename" . "_comments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	$r['unirecidrecord'] = $unirecid;
	$commenti = $tablelinks->xmltable->GetRecords($r);
	if ( $enablecomments )
	{
		echo "<a name=\"___comments\" id=\"___comments\"></a>";
		OpenTableTitle(fn_i18n("_COMMENTI") . " :");
		if (count($commenti) == 0)
		{
			echo "0 ".fn_i18n("_COMMENTI");
		}
		foreach ( $commenti as $commento )
		{
			echo "<div class=\"fnfilescomment\">";
			echo "<b>" . fn_i18n("_DA") . "</b> " . $commento['username'] . " ";
			echo "<b>" . fn_i18n("_DATA") . ":</b> " . (fn_GetDateTime($commento['insert'])) . "<br /><br />";
			echo "<b>" . htmlspecialchars($commento['title']) . "</b><br />";
			echo tag2html($commento['comment']) . "<br /><br /><br />";
			if ( is_admin ( ) )
			{
				$unirecidrecord = $commento['unirecid'];
				echo "<a href=\"javascript:check('?mod={$_FN['mod']}&op=delcomment&id=$unirecid&unirecidrecord=$unirecidrecord')\" >" . fn_i18n("_ELIMINA") . "</a>";
			}
			echo "</div>";
			echo "<hr />";
		}
		if ( $_GET['op'] != "writecomment" )
		{
			if ( $_FN['user'] != "" && $enablecomments != 0 )
			{
				echo "<br />[<img style=\"vertical-align:middle\" src=\"" . fromtheme("images/add.png") . "\" alt=\"\" title=\"\" />&nbsp;";
				echo "<a href=\"index.php?mod={$_FN['mod']}&amp;op=writecomment&amp;id=$unirecid\" >" . fn_i18n("_ADDCOMM") . "</a>]<br />";
			}
			else
			{
				echo fn_i18n("_DEVIREG") . " " . $_FN['sitename'] . " " . fn_i18n("_DEVIREG2");
				fn_loginform();
			}
		}
		CloseTableTitle();
	}
}
/**
 * delcomment
 * 
 * elimina un commento dal record
 * 
 * @param string unirecid record 
 */
function delcomment($unirecid)
{
	global $_FN, $tableborder, $viewpageback;
	global $tablename, $databasename, $recordsperpage, $pathdatabase;
	$tablelinks = new FieldForm("$databasename", "$tablename" . "_comments", $_FN['datadir'], $_FN['lang'], $_FN['languages']);
	if ( is_admin() && isset($_GET['unirecidrecord']) && $_GET['unirecidrecord'] != "" )
	{
		$r['unirecid'] = $_GET['unirecidrecord'];
		$tablelinks->xmltable->DelRecord($r['unirecid']);
		echo fn_i18n("_FILEDELETED") . "<br />";
		FN_log("Comment deleted: table $tablename, record $unirecid");
		$Table = new FieldForm($databasename, $tablename, $pathdatabase, $_FN['lang'], $_FN['languages']);
		$newvalues = $Table->xmltable->GetRecordByPrimaryKey($unirecid);
		if ( $Table->xmltable->fields['update']->type == "datetime" )
			$newvalues['update'] = xmldb_now();
		else
			$newvalues['update'] = time();
		if ( isset($Table->xmltable->fields['recordupdate']) )
			$newvalues['recordupdate'] = xmldb_now();
		$Table->xmltable->UpdateRecord($newvalues);
	}
	viewcomments($unirecid);
}
/**
 * delrecordform
 * schermata eliminazione record
 * */
function delrecordform($unirecid)
{
	global $_FN;
	global $tablename, $databasename, $recordsperpage, $pathdatabase;
	$Table = new XMLTable($databasename, $tablename, $pathdatabase);
	$pkf = $Table->primarykey;
	$row = $Table->GetRecordByPrimaryKey($unirecid);
	$hiderecord = true;
	if ( $row == null )
		fn_i18n("_NONPUOI");
	$username = $_FN['user'];
	if ( !isUser($row, $tablename, $databasename, $pathdatabase) )
		fn_i18n("_NONPUOI");
	if ( !$hiderecord )
	{
		if ( $row != null )
			$Table->DelRecord($unirecid);
		// elimino i permessi sul record
		$restr = array();
		$listuserstable = new XMLTable($databasename, "fieldusers", $pathdatabase);
		//$field['username'] = '-';
		$restr['table_unirecid'] = $row[$listuserstable->primarykey];
		$restr['tablename'] = $tablename;
		//dprint_r($restr);
		$list_field = $listuserstable->GetRecords($restr);
		if ( is_array($list_field) )
		{
			foreach ( $list_field as $field )
			{
				$listuserstable->DelRecord($field['unirecid']);
			}
		}
	}
	else
	{
		$newvalues = array("unirecid" => $unirecid, "recorddeleted" => 1);
		$Table->UpdateRecord($newvalues);
	}
	write_plsitemap();
	echo "<br />" . fn_i18n("_XMBDELOK");
	echo "";
	$tit = fn_i18n("_INDIETRO");
	$listlink = fn_rewritelink("index.php?mod={$_FN['mod']}");
	echo "<br /><br /><button onclick=\"window.location='$listlink'\"><img border=\"0\" style=\"vertical-align:middle\" src=\"" . fromtheme("images/icons/back.png") . "\" alt=\"\">&nbsp;" . fn_i18n("_XMBLISTRECORDS") . "</button>";
	//echo "<br /><img border=\"0\" src=\"sections/{$_FN['vmod']}/icon.png\" alt=\"\"><a href=?mod={$_FN['mod']}>" . _XMBLISTRECORDS . "</a>";
}
/**
 * editrecordform
 * schermata visualizzazione record
 * */
function editrecordform($unirecid, $Table)
{
	global $databasename, $tablename, $pathdatabase, $_FN;
	$tb = new XMLTable($databasename, $tablename, $pathdatabase);
	$pkf = $tb->primarykey;
	$row = $tb->GetRecordByPk($unirecid);
	if ( !isUser($row, $tablename, $databasename, $pathdatabase) )
	{
		request($unirecid);
		return;
	}
	echo "
<script type=\"text/javascript\">
function set_changed()
{
	document.getElementById('exitform').setAttribute('onclick','confirm_exitnosave()');
}

function confirm_exitnosave()
{
	if(confirm ('" . addslashes(fn_i18n("_XMBEXITSAVE")) . "'))
	{
		window.location='?mod={$_FN['mod']}';
	}
}
</script>	
	
	";
	if ( isset($_POST['__NOSAVE']) )
	{
		echo "
<script type=\"text/javascript\">
set_changed();
</script>";
	}
	//onclick=\"if(confirm ('" . fn_i18n ( "_XMBEXITSAVE" ) . "'))window.location='?mod={$_FN['mod']}'\"
	//echo "<form onchange=\"document.getElementById('exitform').setAttribute('onclick','confirm_exitnosave()')\" method=\"post\">";
	//----------visualizza modifica se l' utente e' abilitato ------------>>
	echo "<div class=\"fnfilesuserbar\" >";
	echo "<img border=\"0\" src=\"" . fromtheme("images/useronline/group-admins.gif") . "\" alt=\"\" />&nbsp;<a href=\"index.php?mod={$_FN['mod']}&amp;op=users&amp;id=" . $row[$pkf] . "\" >" . fn_i18n("_MODIFICAUTENTI") . "</a>";
	echo "</div>";
	//----------visualizza modifica se l' utente e' abilitato ------------<<
	echo "<form onchange=\"document.getElementById('exitform').setAttribute('onclick','confirm_exitnosave()')\" enctype=\"multipart/form-data\" action=\"index.php?mod={$_FN['mod']}&amp;op=updaterecord&amp;id=$unirecid\" method=\"post\">";
	$forcelang = isset($_GET['forcelang']) ? $_GET['forcelang'] : $_FN['lang'];
	//$Table = new FieldForm ( $databasename, $tablename, $pathdatabase, $forcelang, $_FN ['languages'] );
	//$Table->setlayoutTags ( "<div style=\"float:left;width:150px;\"><nobr>", ":</nobr></div>", "", "<br />", "<fieldset><legend>", "</legend>", "</fieldset>" . "<br />" );
	$nv = $Table->getbypost();
	$Table->ShowUpdateForm($unirecid, isadmin(), $nv);
	$pk = $Table->xmltable->primarykey;
	echo "<input type=\"hidden\" name=\"$pk\" value=\"$unirecid\" />";
	echo "<input  name=\"xmldbsave\" type=\"submit\" value=\"" . fn_i18n("_SAVE") . "\" />";
	echo "<input type=\"button\" id=\"exitform\" value=\"" . fn_i18n("_XMBEXIT") . "\"  onclick=\"window.location='?mod={$_FN['mod']}'\"/>";
	echo "</form>";
	echo "<br /><img border=\"0\" src=\"" . fromtheme("images/useronline/group-admins.gif") . "\" alt=\"\" />&nbsp;<a href=?mod={$_FN['mod']}&amp;op=users&amp;id=" . $unirecid . ">" . fn_i18n("_MODIFICAUTENTI") . "</a>";
	$listlink = fn_rewritelink("index.php?mod={$_FN['mod']}");
	$tit = fn_i18n("_INDIETRO");
	echo "<br /><br /><button onclick=\"window.location='$listlink'\"><img border=\"0\" style=\"vertical-align:middle\" src=\"" . fromtheme("images/icons/back.png") . "\" alt=\"\">&nbsp;" . fn_i18n("_XMBLISTRECORDS") . "</button>";
	//echo "<br /><img border=\"0\" src=\"sections/{$_FN['vmod']}/icon.png\" alt=\"\"><a href=?mod={$_FN['mod']}>" . fn_i18n ( "_XMBLISTRECORDS" ) . "</a>";
}
/**
 * newrecordform
 * schermata visualizzazione record
 * */
function newrecordform($Table)
{
	global $databasename, $tablename, $pathdatabase, $_FN;
	//$tb = new XMLTable ( $databasename, $tablename, $pathdatabase );
	//----gestione esci senza salvare ------->
	echo "
<script type=\"text/javascript\">
function set_changed()
{
	document.getElementById('exitform').setAttribute('onclick','confirm_exitnosave()');
}

function confirm_exitnosave()
{
	if(confirm ('" . addslashes(fn_i18n("_XMBEXITSAVE")) . "'))
	{
		window.location='?mod={$_FN['mod']}';
	}
}
</script>	
	
	";
	if ( isset($_POST['__NOSAVE']) )
	{
		echo "
<script type=\"text/javascript\">
set_changed();
</script>";
	}
	//----gestione esci senza salvare -------<
	echo "<form onchange=\"document.getElementById('exitform').setAttribute('onclick','confirm_exitnosave()')\" enctype=\"multipart/form-data\" method=\"post\">";
	$forcelang = isset($_GET['forcelang']) ? $_GET['forcelang'] : $_FN['lang'];
	$nv = $Table->getbypost();
	$Table->ShowInsertForm(isadmin(), $nv);
	$pk = $Table->xmltable->primarykey;
	echo "<input name=\"xmldbsave\" type=\"submit\" value=\"" . fn_i18n("_SAVE") . "\" />";
	echo "<input type=\"button\" id=\"exitform\" value=\"" . fn_i18n("_XMBEXIT") . "\" onclick=\"window.location='?mod={$_FN['mod']}'\" />";
	echo "</form>";
}
/**
 * updaterecord
 *
 * Aggiorna il record
 *
 * */
function updaterecord($Table)
{
	global $tablename, $_FN, $databasename, $pathdatabase, $mailalert;
	$username = $_FN['user'];
	if ( $username == "" )
		fn_i18n("_NONPUOI");
	if ( !canaddrecord() )
		fn_i18n("_NONPUOI");
	//$Table = new FieldForm ( $databasename, $tablename, $pathdatabase, $_FN ['lang'], $_FN ['languages'] );
	$newvalues = $Table->getbypost();
	foreach ($newvalues as $key=>$v)
	{
		$newvalues[$key] = securehtml($v);
	}
	$pkf = $Table->xmltable->primarykey;
	if ( $Table->xmltable->fields['update']->type == "datetime" )
		$newvalues['update'] = xmldb_now();
	else
		$newvalues['update'] = time();
	if ( isset($Table->xmltable->fields['recordupdate']) )
		$newvalues['recordupdate'] = xmldb_now();

	//dprint_r($newvalues);
	foreach ( $Table->formvals as $f )
	{
		if ( (isset($Table->formvals[$f['name']]['frm_onrowupdate']) && $Table->formvals[$f['name']]['frm_onrowupdate'] != "" ) )
		{
			$dv = $Table->formvals[$f['name']]['frm_onrowupdate'];
			$fname = $f['name'];
			$rv = "";
			eval("\$rv=$dv;");
			eval("\$newvalues" . "['$fname'] = '$rv' ;");
		}
	}
	$errors = $Table->VerifyExt($newvalues, false);
	if ( count($errors) > 0 )
	{
		$txterr = _FERRCAMPO;
		foreach ( $errors as $field => $error )
		{
			$Table->setlayoutTag($field, "<b>", ":</b>&nbsp;<span style=\"background-color:#ffffff;color:red\">{$error['error']}</span>", "<br />", "<br /><br />", "<fieldset><legend>", "</legend>", "", "</fieldset>");
			$tt = $Table->formvals[$field]['title'];
			$txterr.="\n\n{$tt} : " . html_entity_decode($error['error']);
		}
		jsalert($txterr);
	}
	if ( count($errors) == 0 )
	{
		if ( is_admin ( ) )
		{
			if ( !isset($_POST['userupdate']) || $_POST['userupdate'] == "" )
			{
				$_POST['userupdate'] = $newvalues['userupdate'] = $_FN['user'];
			}
		}
		else
			$newvalues['userupdate'] = $_FN['user'];
		//-----verifica se sono abilitato all' aggiornamento ---------------
		if ( $Table->xmltable->fields['update']->type == "datetime" )
			$newvalues['update'] = xmldb_now();
		else
			$newvalues['update'] = time();
		if ( isset($Table->xmltable->fields['recordupdate']) )
			$newvalues['recordupdate'] = xmldb_now();

		$Table->xmltable->UpdateRecord($newvalues);
		FN_log("Record modified: table $tablename, record {$newvalues['unirecid']}");
		jsalert(fn_i18n("_XMBRECORDUPDATED"));
		//echo "<br />" . fn_i18n ( "_XMBRECORDUPDATED" );
		//echo "<hr />";
	}
	editrecordform($newvalues[$pkf], $Table);
}
/**
 * insertrecord
 * INSERISCE UN RECORD E DICE SE E' stato inserito
 *
 * */
function insertrecord($Table)
{
	global $_FN;
	//-----verifica se sono abilitato all' inserimento ---------------
	$username = $_FN['user'];
	if ( !canaddrecord() )
		fn_i18n("_NONPUOI");
	global $tablename, $databasename, $pathdatabase;
	$newvalues = $Table->getbypost();
	foreach ($newvalues as $key=>$v)
	{
		$newvalues[$key] = securehtml($v);
	}

	$pkf = $Table->xmltable->primarykey;
	//------TIME UPDATE/INSERT---->
	if ( $Table->xmltable->fields['update']->type == "datetime" )
	{
		$newvalues['update'] = xmldb_now();
	}
	else
	{
		$newvalues['update'] = time();
	}
	if ( $Table->xmltable->fields['insert']->type == "datetime" )
	{
		$newvalues['insert'] = xmldb_now();
	}
	else
	{
		$newvalues['insert'] = time();
	}
	if ( isset($Table->xmltable->fields['recordupdate']) )
		$newvalues['recordupdate'] = xmldb_now();
	if ( isset($Table->xmltable->fields['recordinsert']) )
		$newvalues['recordinsert'] = xmldb_now();
	//------TIME UPDATE/INSERT----<

	$newvalues['username'] = $username;
	foreach ( $Table->formvals as $f )
	{
		if ( (isset($Table->formvals[$f['name']]['frm_onrowupdate']) && $Table->formvals[$f['name']]['frm_onrowupdate'] != "" ) )
		{
			$dv = $Table->formvals[$f['name']]['frm_onrowupdate'];
			$fname = $f['name'];
			$rv = "";
			eval("\$rv=$dv;");
			eval("\$newvalues" . "['$fname'] = '$rv' ;");
		}
	}
	$errors = $Table->VerifyExt($newvalues);
	if ( count($errors) > 0 )
	{
		foreach ( $errors as $field => $error )
		{
			$Table->setlayoutTag($field, "<b>", ":</b>&nbsp;<span style=\"background-color:#ffffff;color:red\">{$error['error']}</span>", "<br />", "<br /><br />", "<fieldset><legend>", "</legend>", "", "</fieldset>");
		}
	}
	if ( count($errors) == 0 )
	{

		$record = $Table->xmltable->InsertRecord($newvalues);
		$nrec = array();
		$nrec['view'] = $record[$pkf];
		$nrec[$pkf] = $record[$pkf];
		$record = $Table->xmltable->UpdateRecord($nrec);
		//------ aggiorno la tabella degli utenti associati alla riga
		$users = new XMLTable($databasename, "fieldusers", $pathdatabase);
		$r = array();
		$r['tablename'] = $tablename;
		$r['username'] = $username;
		$r['table_unirecid'] = $record[$pkf];
		$users->InsertRecord($r);
		FN_log("Record added: table $tablename, record {$record[$pkf]}");
		jsalert(fn_i18n("_XMBRECORDINSERIT"));
		global $mailalert, $_FN, $site_email_address, $site_email_address;
		//----mail inserimento nuovo record -------->
		if ( $mailalert != "" )
		{
			$tmp = str_replace("none_", "", $_FN['vmod']);
			$tmp = preg_replace("/^[0-9][0-9]_/si", "", $tmp);
			$tmp = getLang("sectons/{$_FN['vmod']}/lang.xml", $tmp);
			$subject = fn_i18n("_XMBINSERTMAIL") . " $tmp: " . $record['name'];
			if ( strtoupper(substr(PHP_OS, 0, 3) == 'WIN') )
			{
				$eol = "\r\n";
			}
			elseif ( strtoupper(substr(PHP_OS, 0, 3) == 'MAC') )
			{
				$eol = "\r";
			}
			else
			{
				$eol = "\n";
			}
			$body = "$eol" . fn_i18n("_XMBINSERTBY") . " " . $r['username'];
			$body .= "$eol$eol" . fn_i18n("_XMADDRESSVIEW") . ": ";
			$body .= "$eol" . $_FN['siteurl'] . "/index.php?mod={$_FN['vmod']}&op=view&id=" . $record['unirecid'];
			$body .= "$eol$eol" . $_FN['sitename'] . "";
			mail("$mailalert", "$subject", $body, "From: $site_email_address\r\n" . "Reply-To: $site_email_address\r\n" . "X-Mailer: PHP/" . phpversion());
		}
		//----mail inserimento nuovo record --------<
		editrecordform($record[$pkf], $Table);
	}
	else
	{
		newrecordform($Table);
	}
}
/**
 * getFieldUser
 * torna il proprietario di un record
 *
 * @param string $row
 * @param string $tablename
 * @param string $databasename
 * @param string $pathdatabase
 * 
 */
function getFieldUser($row, $tablename, $databasename, $pathdatabase)
{
	$tb = new XMLTable($databasename, $tablename, $pathdatabase);
	$listusers = new XMLTable($databasename, "fieldusers", $pathdatabase);
	$pkf = $tb->xmltable->primarykey;
	$restr = array();
	$restr['table_unirecid'] = $row[$pkf];
	$restr['tablename'] = $tablename;
	$field = $listusers->GetRecord($restr);
	if ( isset($field['username']) )
		return $field['username'];
	else
		return "";
}
/**
 * getFieldUserList
 * torna gli utenti abilitati a modificare un record
 * @param string $row
 * @param string $tablename
 * @param string $databasename
 * @param string $pathdatabase
 */
function getFieldUserList($row, $tablename, $databasename, $pathdatabase = "misc")
{
	//restrizioni per la 'pseudoquery'
	$restr = array();
	$listusers = new XMLTable($databasename, "fieldusers", $pathdatabase);
	//$field['username'] = '-';
	$restr['table_unirecid'] = $row[$listusers->primarykey];
	$restr['tablename'] = $tablename;
	//dprint_r($restr);
	$list_field = $listusers->GetRecords($restr);
	//dprint_r($list_field);
	return $list_field;
}
/**
 * isUser
 * torna true se l' utente corrente pu? modificare il record
 * @param string $row
 * @param string $tablename
 * @param string $databasename
 * @param string $pathdatabase */
function isUser($row, $tablename, $databasename, $pathdatabase = "misc")
{
	global $_FN;
	if ( isadmin ( ) )
		return true;
	$user = $_FN['user'];
	if ( isset($row['username']) && $row['username'] == $_FN['user'] )
		return true;
	if ( isset($row['user']) && $row['user'] == $user )
		return true;
	$listusers = new XMLTable($databasename, "fieldusers", $pathdatabase);
	$t = xmldb_table($databasename, $tablename, $pathdatabase);

	$restr = array();
	$restr['table_unirecid'] = $row[$t->primarykey];
	$restr['tablename'] = $tablename;
	$restr['username'] = $user;
	$list_field = $listusers->GetRecords($restr);
	$unirecid = $row[$t->primarykey];
	if ( is_array($list_field) )
		foreach ( $list_field as $field )
		{
			//echo "<br />--";print_r($field);
			if ( $field['username'] == $user && $field['table_unirecid'] == $row[$t->primarykey] && $field['tablename'] == $tablename )
				return true;
		}
	return false;
}
/**
 * canaddrecord
 * torna true se l' utente pu? aggiungere un record
 */
function canaddrecord()
{
	global $_FN;
	if ( isadmin ( ) )
		return true;
	$groupinsert = "";
	include ("sections/" . $_FN['vmod'] . "/config.php");
	if ( $_FN['user'] == "" || $groupinsert == "" )
	{
		return false;
	}
	return user_in_group($_FN['user'], $groupinsert);
}
/**
 * makebr
 * 
 * trasforma i /n in <br />
 * @param $text
 */
function makebr($text)
{
	global $_FN;
	return str_replace("\n", "<br " . $_FN['close_tag'] . ">", $text);
}
/**
 * usersform
 * schermata visualizzazione record
 */
function usersform($unirecid)
{
	global $_FN, $databasename, $tablename, $pathdatabase;
	include ("sections/" . $_FN['vmod'] . "/config.php");
	$Table = new XMLTable($databasename, $tablename, $pathdatabase, $_FN['lang']);
	$row = $Table->GetRecordByPrimaryKey($unirecid);
	$pk = $Table->primarykey;
	$usertoadd = getparam("usertoadd", PAR_POST, SAN_FLAT);
	$usertodel = getparam("usertodel", PAR_GET, SAN_FLAT);
	if ( $usertodel != "" )
	{
		$fieldusers = new XMLTable($databasename, "fieldusers", $pathdatabase);
		$r = array();
		$r['tablename'] = $tablename;
		$r['username'] = $usertodel;
		$r['table_unirecid'] = $unirecid;
		$old = $fieldusers->GetRecords($r);
		if ( !isset($old[0]) )
			echo "error delete:" . fn_i18n("_USERNOTEXISTS");
		$old = $old[0];
		$fieldusers->DelRecord($old[$fieldusers->primarykey]);
	}
	if ( $usertoadd != "" )
	{
		if ( get_user($usertoadd) == null )
		{
			echo fn_i18n("_USERNOTEXISTS");
		}
		else
		if ( UserCanEditField($usertoadd, $row) )
		{
			echo fn_i18n("_USERYETEN");
		}
		else
		{
			//dprint_r($usertoadd);
			$fieldusers = new XMLTable($databasename, "fieldusers", $pathdatabase);
			$r = array();
			$r['tablename'] = $tablename;
			$r['username'] = $usertoadd;
			$r['table_unirecid'] = $unirecid;
			//dprint_r($r);
			$fieldusers->InsertRecord($r);
			if ( strtoupper(substr(PHP_OS, 0, 3) == 'WIN') )
			{
				$eol = "\r\n";
			}
			elseif ( strtoupper(substr(PHP_OS, 0, 3) == 'MAC') )
			{
				$eol = "\r";
			}
			else
			{
				$eol = "\n";
			}
			global $siteurl, $sitename, $site_email_address;
			$message = fn_i18n("_XMBSEISTATOAGGIUNTO") . " \"" . $row['name'] . "\" \n\n";
			$message .= fn_i18n("_XMBSEISTATOAGGIUNTO2") . $siteurl . "index.php?mod=login\n";
			$message .= fn_i18n("_XMBREQUESTMESSAGE5") . "\"$usertoadd\"\n";
			$message .= fn_i18n("_XMBREQUESTMESSAGE3") . "\n" . "$siteurl" . "index.php?mod={$_FN['mod']}&op=edit&id=$unirecid\n";
			$message = str_replace("\r", "", $message);
			$message = str_replace("\n", $eol, $message);
			$user_record = get_user($usertoadd);
			$subject = "[$sitename] " . $row['name'];
			mail($user_record['email'], $subject, $message, "From: $site_email_address" . $eol);
			FN_log("User added: user $usertoadd table $tablename, record $unirecid ({$row['name']})");
		}
	}
	if ( !isUser($row, $tablename, $databasename) )
		fn_i18n("_NONPUOI");
?>
	<form
		action="index.php?mod=<?php echo $_FN['vmod'] ?>&amp;op=users&amp;id=<?php echo $row['unirecid'] ?>"
		method="post">
		<table>
			<tr>
				<td><?php
	echo fn_i18n("_FNADDUSER");
?></td>
			<td></td>
			<td><input type="text" name="usertoadd" /></td>
		</tr>
		<tr>
			<td colspan="2"><input type="hidden" name="<?php echo $pk ?>"
								   value="<?php echo $unirecid ?>" /> <input type="submit" /></td>
		</tr>
	</table>
</form>
<?php
				$users = array();
				$users = getFieldUserList($row, $tablename, $databasename, $pathdatabase);
				//dprint_r(" getFieldUserList($row, $tablename, $databasename, $pathdatabase);");
				if ( is_array($users) )
					foreach ( $users as $user )
					{
						//echo "<form  action=\"index.php?mod={$_FN['mod']}&amp;op=updaterecord&amp;deluser=".$user['username']."\" method=\"POST\" > ";
						echo "<br />" . $user['username'] . "<input type=\"button\" value=\"" . fn_i18n("_ELIMINA") . "\" onclick=\"check('?mod={$_FN['mod']}&amp;id=" . $row[$pk] . "&amp;op=users&amp;usertodel=" . $user['username'] . "')\" />";
						//echo "</form>";
					}
				//viewrecordpage($unirecid);
				echo "<hr />";
				$listlink = fn_rewritelink("index.php?mod={$_FN['mod']}&amp;op=view&amp;id={$row[$pk]}");
				echo "<img src='" . fromtheme("images/icons/doc.png") . "' alt='' border='0' /><a href=\"$listlink\">" . fn_i18n("_XMBVIEW") . "</a>";
				$listlink = fn_rewritelink("index.php?mod={$_FN['mod']}");
				echo "<br /><br /><button onclick=\"window.location='$listlink'\"><img border=\"0\" style=\"vertical-align:middle\" src=\"" . fromtheme("images/icons/back.png") . "\" alt=\"\">&nbsp;" . fn_i18n("_XMBLISTRECORDS") . "</button>";
			}
			function UserCanEditField($user, $row)
			{
				global $tablename, $databasename, $pathdatabase;
				$restr = array();
				$restr['table_unirecid'] = $row['unirecid'];
				$restr['tablename'] = $tablename;
				$restr['username'] = $user;
				$list_field = getFieldUserList($row, $tablename, $databasename, $pathdatabase);
				$unirecid = $row['unirecid'];
				if ( is_array($list_field) )
					foreach ( $list_field as $field )
					{
						//echo "<br />--";print_r($field);
						if ( $field['username'] == $user && $field['table_unirecid'] == $row['unirecid'] && $field['tablename'] == $tablename )
							return true;
					}
				return false;
			}
			function write_plsitemap()
			{
				global $generate_html_sitemap, $generate_googlesitemap;
				global $languages;
				global $_FN;
				global $tablename, $pathdatabase, $databasename, $recordsperpage, $_pluginfieldform, $_FN;
				if ( $generate_googlesitemap )
				{
					$sBasePath = $url = "http://" . $_SERVER["HTTP_HOST"] . DirName($_SERVER['PHP_SELF']);
					$Table = new XMLTable($databasename, $tablename, $pathdatabase, $_FN['lang']);
					$fieldstoread = "name|unirecid";
					$data = $Table->GetRecords(false, false, false, false, false, $fieldstoread);
					$handle = fopen("sitemap-$tablename.xml", "w");
					fwrite($handle, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n");
					$list_languages = explode(",", $languages);
					fwrite($handle, "<url>\n\t<loc>$sBasePath/index-$tablename.html</loc>\n</url>\n");
					foreach ( $data as $row )
					{
						$unirecid = $row['unirecid'];
						fwrite($handle, "<url>\n\t<loc>$sBasePath/" . fn_rewritelink("index.php?mod={$_FN['idmod']}&amp;op=view&amp;id=$unirecid") . "</loc>\n</url>\n");
					}
					fwrite($handle, "\n</urlset>");
					fclose($handle);
				}
				if ( $generate_html_sitemap )
					write_index();
			}
			function write_index()
			{
				global $languages;
				global $_FN;
				$sBasePath = $url = "http://" . $_SERVER["HTTP_HOST"] . DirName($_SERVER['PHP_SELF']);
				global $tablename, $pathdatabase, $databasename, $recordsperpage, $_pluginfieldform, $_FN;
				$Table = new XMLTable($databasename, $tablename, $pathdatabase, $_FN['lang']);
				$fieldstoread = "name|unirecid";
				$data = $Table->GetRecords(false, false, false, false, false, $fieldstoread);
				$title = "";
				$list_languages = explode(",", $languages);
				$sep = "";
				$str = "";
				foreach ( $list_languages as $l )
				{
					$text = getLang("sections/{$_FN['vmod']}/lang.xml", str_replace("_", "", preg_replace("/^[0-9][0-9]_/si", "", str_replace("none_", "", $_FN['vmod']))), $l);
					$oUnicodeReplace = new unicode_replace_entities();
					$text = $oUnicodeReplace->UTF8entities($text);
					$text = str_replace("'", "&#039;", $text);
					$text = str_replace('"', "&quot;", $text);
					$title .= "$sep" . $text;
					$sep = "-";
				}
				$nomi = "$title";
				foreach ( $data as $row )
				{
					$nome = htmlspecialchars($row['name']);
					$nomi .= "," . str_replace('"', '', $nome);
				}
				$str .= "<html>\n<head>\n\t<title>$title</title>";
				echo "<link rel='StyleSheet' type='text/css' href='themes/{$_FN['theme_default']}/style.css' />";
				$str .= "\n\t<meta name=\"KEYWORDS\" content=\"$nomi\" />";
				$str .= "\n</head>\n<body>";
				$str .= "\n<h1>$title</h1>\n";
				$str .= "<a href=\"$sBasePath/" . fn_rewritelink("index.php?mod={$_FN['idmod']}") . "\">$title</a><br />\n";
				$str .= "<ul>";
				$list_languages = explode(",", $languages);
				foreach ( $data as $row )
				{
					$unirecid = $row['unirecid'];
					$nome = $row['name'];
					$nomi .= ",$nome";
					$str .= "\n\t<li>";
					$str .= "<a href=\"$sBasePath/" . fn_rewritelink("index.php?mod={$_FN['vmod']}&amp;op=view&amp;id=$unirecid") . "\" >$nome</a><br />";
					$str .= "</li>";
				}
				$str .= "\n</ul>";
				$str .= "\n</body></html>";
				$handle = fopen("index-$tablename.htm", "w");
				fwrite($handle, $str);
				fclose($handle);
			}
			function request($unirecid)
			{
				global $_FN, $databasename, $tablename, $pathdatabase, $siteurl, $site_email_address, $sitename;
				if ( strtoupper(substr(PHP_OS, 0, 3) == 'WIN') )
				{
					$eol = "\r\n";
				}
				elseif ( strtoupper(substr(PHP_OS, 0, 3) == 'MAC') )
				{
					$eol = "\r";
				}
				else
				{
					$eol = "\n";
				}
				if ( $_FN['user'] == "" )
				{
					jsredirect("index.php?mod={$_FN['mod']}&op=view&id=$unirecid");
				}
				if ( isset($_POST['message']) )
				{
					$Table = new FieldForm($databasename, $tablename, $pathdatabase, $_FN['lang'], $_FN['languages']);
					$row = $Table->xmltable->GetRecordByPrimaryKey($unirecid);
					$user_record = get_user($row['username']);
					$user = get_user($_FN['user']);
					$subject = "[$sitename] " . $row['name'];
					$message = $_FN['user'] . " " . fn_i18n("_XMBREQUESTMESSAGE") . " \"" . $row['name'] . "\"\n\n\n";
					$message .= fn_i18n("_XMBREQUESTMESSAGE2") . " " . $siteurl . "index.php?mod=login$eol";
					$message .= fn_i18n("_XMBREQUESTMESSAGE5") . "\"" . $user_record['username'] . "\"$eol\n\n";
					$message .= fn_i18n("_XMBREQUESTMESSAGE3") . "\n" . "$siteurl" . "index.php?mod={$_FN['mod']}&op=edit&id=$unirecid\n";
					$message .= fn_i18n("_XMBREQUESTMESSAGE4") . " " . "\"{$_FN['user']}\"";
					$message .= "$eol$eol----------------------$eol";
					$message .= "$eol" . strippostpslashes($_POST['message']);
					$message = str_replace("\r", "", $message);
					$message = str_replace("\n", $eol, $message);
					mail($user_record['email'], $subject, $message, "From: $site_email_address" . $eol);
					echo "<br />" . fn_i18n("_XMBRMESSAGGIOINVIATO") . "<br />";
					FN_log("Request: table $tablename, record $unirecid ({$row['name']})");
				}
				else
				{
					echo fn_i18n("_XMBRICHIEDI2") . "<br />";
					echo "<form method=\"post\" action=\"index.php?mod={$_FN['mod']}&amp;op=request&amp;id=$unirecid\">";
					echo "<textarea name=\"message\" cols=\"60\" rows=\"5\"></textarea><br />";
					echo "<input type=\"submit\"  name=\"send\" value=\"" . fn_i18n("_XMBRICHIEDI") . "\" class=\"submit\" />";
					echo "\n<input type=\"button\" onclick=\"window.location='index.php?mod={$_FN['mod']}'\" class=\"button\" value=\"" . fn_i18n("_CANCEL") . "\" />";
					echo "</form>";
				}
				$listlink = fn_rewritelink("index.php?mod={$_FN['mod']}");
				$tit = fn_i18n("_INDIETRO");
				echo "<br /><br /><button onclick=\"window.location='$listlink'\"><img border=\"0\" style=\"vertical-align:middle\" src=\"" . fromtheme("images/icons/back.png") . "\" alt=\"\">&nbsp;" . fn_i18n("_XMBLISTRECORDS") . "</button>";
			}
			/**
			 * ux_bbcode
			 * sostituisce la xmldbforn_show_textarea
			 * 
			 */
			function ux_bbcode($name, $value, $rows, $cols, $tooltip)
			{
				//echo "<table border=\"1\"><tr><td>$name:</td></tr><tr><td>";
				bbcodes_panel($name, "formatting");
				bbcodes_panel($name, "emoticons");
				bbcodes_js();
				echo "<textarea title=\"$tooltip\" cols=\"$cols\"  rows=\"$rows\"  name=\"" . $name . "\"  >";
				echo htmlspecialchars($value);
				echo "</textarea>";
			}
			function html_rank($id, $small = true, $tablename)
			{
				$n = 0;
				$rank = get_rank($id, $n, $tablename);
				$html = "";
				$s = "";
				if ( $small )
					$s = "_small";
				$html .= "<div style=\"display:inline;line-height:10px;\">";
				if ( $rank >= 0 )
					for ( $i = 0; $i < 5; $i++ )
					{
						if ( $i < $rank )
						{
							$html .= "<img style=\"\" alt=\"\" src=\"images/star$s.png\" />";
						}
						else
						{
							$html .= "<img style=\"\" alt=\"\" src=\"images/star_gray$s.png\" />";
						}
					}
				else
					$html .= "-";
				$html .= "</div>";
				//	$html .= "<span style=\"font-size:10px\"> $n voti</span>&nbsp;";
				//	$view = ops_get_view ( $id, $tablename );
				//	$html .= "<span style=\"font-size:10px\"> $view visite</span></div>";
				return $html;
			}
			/**
			 * ricava il rank di una scheda
			 *
			 * @param int $id
			 * @return int
			 */
			function get_rank($id, &$n, $tablename)
			{
				global $_FN, $databasename;
				static $table = false;
				$res = false;
				if ( !$table )
					$table = new XMLTable("$databasename", $tablename . "_ranks", $_FN['datadir']);
				$res = $table->GetRecords(array("unirecidrecord" => "$id"));
				$total = 0;
				if ( !is_array($res) )
					$res = array();
				$n = count($res);
				if ( $n == 0 )
					return -1;
				foreach ( $res as $r )
				{
					$total += $r['rank'];
				}
				$m = round(($total / $n), 0);
				return $m;
			}
			/**
			 * Enter description here...
			 *
			 * @param unknown_type $id
			 * @param unknown_type $tablename
			 * @return unknown
			 */
			function html_rank_editable($id, $small = true, $tablename)
			{
				global $_FN;
				$n = 0;
				$s = "";
				if ( $small )
					$s = "_small";
				$cookie = getparam("fnfiles_rank_{$tablename}_{$id}", PAR_COOKIE, SAN_FLAT);
				if ( $cookie == "true" || $_FN['user'] == "" )
					return fn_i18n("_RANK") . " : " . html_rank($id, $small, $tablename);
				//$rank = pdit_get_rank ( $id, $n ,$tablename);
				$html = "";
				$smalltxt = "small=0";
				if ( $small )
					$smalltxt = "small=1";
				$html .= "
<script  type=\"text/javascript\">
function set_rank(v)
{
	window.location=\"{$_FN['siteurl']}index.php?mod={$_FN['mod']}&op=view&id=$id&setrank=\"+v+\"&#___ranks\";
}
function select_star(c)
{
	var images = document.getElementById('pdit_rank').getElementsByTagName('img');
	for (var i in images)
	{
		if ((i) >= c)
			images[i].src='images/star_gray$s.png';
		else
			images[i].src='images/star$s.png';
	}
}
</script>

";
				//$view = pdit_get_view ( $id, $tablename );
				$html .= "<div style=\"height:20px;\">" . fn_i18n("_VOTA") . " : ";
				$html .= "<div style=\"display:inline\" id=\"pdit_rank\">";
				$votes = array(1 => fn_i18n("_RANK1"), 2 => fn_i18n("_RANK2"), 3 => fn_i18n("_RANK3"), 4 => fn_i18n("_RANK4"), 5 => fn_i18n("_RANK5"));
				foreach ( $votes as $i => $votes )
				{
					$html .= "<img onmouseout=\"select_star(-1);document.getElementById('pdit_rank_desc').innerHTML='&nbsp;'\" onmouseover=\"select_star($i);document.getElementById('pdit_rank_desc').innerHTML='{$votes}'\" onclick=\"set_rank($i)\" style=\"vertical-align:middle;cursor:pointer;\" alt=\"\" src=\"images/star_gray$s.png\" />";
				}
				$html .= "<div style=\"margin-left:10px;display:inline\" id=\"pdit_rank_desc\" >&nbsp;</div>";
				$html .= "</div>";
				$html .= "</div>";
				return $html;
			}
			function fnfiles_set_rank($id, $rank, $tablename)
			{
				global $_FN, $databasename;
				$rank = intval($rank);
				if ( $rank > 5 || $rank < 0 )
					return;
				$table = new XMLTable("$databasename", "{$tablename}_ranks", $_FN['datadir']);
				$table->InsertRecord(array("unirecidrecord" => "$id", "rank" => $rank));
			}
?>