<?php
/**
 * @package flatnux_section_login
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}

if (  !function_exists("openloginform") )
{
	/**
	 * openloginform
	 **/
	function openloginform()
	{
		echo "<div style=\"text-align:center;\" >";
	}
}

if (  !function_exists("closeloginform") )
{
	/**
	 * closeloginform
	 **/
	function closeloginform()
	{
		echo "</div>";
	}
}

/**
 * execute registration
 *
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @param string $goto
 * @return bool
 */
function reg($goto = "")
{
	$ret = false;
	global $_FN;
	if ( $goto == "" )
		$goto = "index.php";

	if ( $_FN['enable_registration'] == 0 &&  !is_admin() )
	{
		echo fn_i18n("_NONPUOI");
		return $ret;
	}

	$nusers = count_users();
	echo "<br /><br />";
	//apre la tabella -->
	openloginform();
	echo "\n<table>" . "\n<tbody>";
	echo "\n<tr>" . "\n<td style=\"text-align:center\" colspan=\"5\" >";
	//apre la tabella --<


	//------------riempo i campi--------------------
	$fields = new FieldForm("fndatabase","users",$_FN['datadir'],$_FN['lang']);
	$newvalues = array();
	foreach ( $fields->formvals as $key=>$value )
	{
		if ( isset($value['type']) && ($value['type'] == 'image' || $value['type'] == 'file') && isset($_FILES[$key]['name']) )
		{
			if ( $_FILES[$key]['name'] != "" )
				$newvalues[$key] = $_FILES[$key]['name'];
		}
		else
			$newvalues[$key] = htmlspecialchars(getparam($key,PAR_POST,SAN_FLAT));
	}
	if ( $_FN['registration_by_email'] == 1 && count_users() > 0 )
	{
		$newvalues['active'] = 0;
	}
	else
	{

		$newvalues['active'] = 1;
	}

	//--questi li forzo
	$rnd = $newvalues['rnd'] = rand();
	$newvalues['ip'] = $_SERVER["REMOTE_ADDR"];
	$newvalues['group'] = "users";
	//--livello
	if ( is_admin() )
	{
		$newvalues['active'] = htmlspecialchars(getparam('active',PAR_POST,SAN_FLAT));
		$newvalues['level'] = htmlspecialchars(getparam('level',PAR_POST,SAN_FLAT));
		//compongo la stringa del gruppo
		$groups = get_grouplist();
		$newgroup = "";
		$i = 0;
		foreach ( $groups as $g )
		{
			if ( isset($_POST['group-' . $g]) )
				$newgroup .= $g . ",";
			$i++ ;
		}
		if ( $newgroup != "" )
			$newgroup = substr($newgroup,0,strlen($newgroup) - 1);
		$newvalues['group'] = $newgroup;
	}
	else
	{
		if ( count_users() == 0 )
			$newvalues['level'] = 10;
		else
			$newvalues['level'] = 0;
		if ( $_FN['registration_by_email'] == 1 && count_users() > 0 )
			$newvalues['active'] = 0;
		else
			$newvalues['active'] = 1;
	}
	//mxonline
	$prk = $fields->xmltable->primarykey;
	$nome = $newvalues[$prk] = $newvalues[$prk];

	//---validazione dei campi
	$err = $fields->Verify($newvalues);
	if ( $err != "" )
	{
		echo fn_i18n("_FERRCAMPO") . " :<br /><br />$err<br />";
		$tit = fn_i18n("_INDIETRO");
		echo "<a accesskey=\"" . getaccesskey($tit,"javascript:history.back()") . "\" href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
	}
	else
	{

		//password in md5
		$newvalues['passwd'] = md5($newvalues['passwd']);
		$email = $newvalues['email'];

		//---inserisce nel db--->
		$fields->xmltable->InsertRecord($newvalues);
		//---inserisce nel db---<


		//----inserimento del record
		if ( $_FN['registration_by_email'] == 1 && $nusers > 0 ) // se e' una registrazione con conferma manda l' email
		{
			//recupero l' indirizzo del server
			$server = $_FN['siteurl'] . "index.php";
			$nome_utente = $nome;
			if ( is_admin() && $newvalues['active'] == 1 )
			{
				echo "<br />" . fn_i18n("_USER_REGIST") . "<br />";
			}
			else
			{
				echo "<br /><br />" . fn_i18n("_COMP_REG") . " " . htmlentities($_POST['email']) . fn_i18n("_COMP_REG2") . "<br />";
			}
			print("<br /><div ><a href=\"$goto\">" . fn_i18n("_AVANTI") . " &gt;&gt;&gt;</a></div>");

			$link = "$server" . "?mod=" . $_FN['mod'] . "&new_user=true&op=end_reg&registra=true&user=".urlencode($nome_utente)."&id=$rnd";

			$confirmation_message = file_get_contents($_FN['datadir'] . "/messages/" . $_FN['lang'] . "/mail_confirmation_message.txt");
			$mail = str_replace("!CONFIRMREGISTRATIONADDRESS!",$link,$confirmation_message);
			$mail = str_replace("!USERNAME!",$nome,$mail);
			$mail = str_replace("!SITENAME!",$_FN['sitename'],$mail);
			// se non c' il link lo metto
			if (  !strstr($mail,$link) )
				$mail .= "\n$link";

			if ( strtoupper(substr(PHP_OS,0,3) == 'WIN') )
			{
				$eol = "\r\n";
			}
			elseif ( strtoupper(substr(PHP_OS,0,3) == 'MAC') )
			{
				$eol = "\r";
			}
			else
			{
				$eol = "\n";
			}

			//fix newline
			$mail = str_replace("\r","",$mail);
			$mail = str_replace("\n","$eol",$mail);

			if ( is_admin() && $newvalues['active'] == 1 )
			{
				//utente inserito a mano
			}
			else
			{
				mail($email,fn_i18n("_SUB_REG_MAIL"),$mail,"From: {$_FN['site_email_address']}$eol" . "Reply-To: {$_FN['site_email_address']}$eol");
			}
			$ret = false;
		}
		else
		{
			if ( $_FN['registration_by_email'] != 1 && function_exists("FN_OnValidateUsers") )
			{
				FN_OnValidateUsers($newvalues);
			}

			fn_login($nome);
			fn_send_mail_registration($nome);
			$ret = true;
		}
	}
	echo "</td></tr></tbody></table>";
	closeloginform();

	return $ret;

}

/**
 * vis_reg
 *
 * schermata di registrazione nuovo utente
 *
 **/
function vis_reg()
{
	global $_FN,$forumborder,$forumback;
	if ( $_FN['enable_registration'] == 0 &&  !is_admin() )
	{
		echo fn_i18n("_NONPUOI");
		return;
	}
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	$from = getparam("from",PAR_GET,SAN_HTML);
	openloginform();
	echo "<form enctype=\"multipart/form-data\" action=\"?mod=" . $_FN['mod'] . "&amp;opt=$op&amp;op=reg\" method=\"post\" name=\"registra\" >";
	//apre la tabella -->
	echo "<fieldset>";
	echo "<legend>" . fn_i18n("_FREG") . "</legend>";
	echo "\n<table>" . "\n<tbody>";
	echo "\n<tr>" . "\n<td style=\"text-align:center\" colspan=\"2\" >";
	//apre la tabella --<
	echo "<b>" . fn_i18n("_FCAMPI") . "</b><br />&nbsp;";
	echo "</td>";
	echo "</tr>";

	$_fnextrauservalues = new FieldForm("fndatabase","users",$_FN['datadir'],$_FN['lang']);
	$_fnextrauservalues->setlayoutTags("<tr><td style=\"text-align:right;vertical-align:top\">","</td>","<td style=\"text-align:left;vertical-align:top\">","</td></tr>");
	$_fnextrauservalues->ShowInsertForm(isadmin());

	if ( isadmin() )
	{
		//livello-->
		echo "<tr><td>" . fn_i18n("_LEVEL") . "</td>";
		echo "<td>";
		echo "<select name=\"level\">";
		for ( $i = 0;$i < 11;$i++  )
		{
			echo "<option value=\"$i\" >$i</option>";
		}
		echo "</select>";
		echo "</td></tr>";
		//livello--<
		//gruppo-->
		echo "<tr><td>" . fn_i18n("_FGRUPPO") . "</td>";
		echo "<td>";
		$groups = get_grouplist();
		$group = "users";
		$grlist = explode(",",$group);
		foreach ( $groups as $g )
		{
			$ck = in_array($g,$grlist) ? "checked=\"true\"" : "";
			print("<input $ck name=\"group-$g\" value=\"$group\" type=\"checkbox\" />$g<br />");
		}
		echo "</td></tr>";
		//gruppo--<
	}
	//invia--<
	echo "<tr><td>&nbsp;</td><td ><br /><input type=\"submit\" class=\"submit\" value=\"" . fn_i18n("_FINVIA") . "\" /><br />&nbsp;</td></tr>";
	//invia--<
	echo "</tbody></table>";
	echo "</fieldset>";
	echo "</form>";
	$tit = fn_i18n("_RETURN_HOME");
	echo "<a accesskey=\"" . getaccesskey($tit,"index.php") . "\" href=\"index.php\">$tit</a>";
	closeloginform();
}

/**
 * vis_login
 * Visualizza una schermata di login
 *
 **/
function vis_login()
{
	global $_FN;
	global $forumback,$forumborder;
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
	{
		$fbackborder = "style=\"margin:auto;background-color:#$forumborder\" cellspacing=\"1\" cellpadding=\"2\"";
	}
	if ( $forumback != "" )
		$fbackground = "style=\"margin:auto;background-color:#$forumback\"";
	if ( is_logged_in() ) //se sono gia' loggato vado alla schermata principale
	{
		profile();
		return;
	}
	$from = getparam("from",PAR_GET,SAN_FLAT);
	echo "<form action=\"?mod=login\" method=\"post\" >";
	openloginform();
	echo "<table $fbackborder><tbody>";
	echo "\n<tr><td colspan=\"2\" $fbackground><b>" . fn_i18n("_FLOGIN") . "</b></td></tr>";
	echo "\n<tr><td $fbackground><input type=\"hidden\" name=\"op\" value=\"login\" />" . fn_i18n("_NOMEUTENTE") . ":" . "</td>";
	echo "<td $fbackground><input name=\"nome\" value=\"\"/></td></tr>";
	echo "\n<tr><td $fbackground><input type=\"hidden\" name=\"from\" value=\"$from\" />" . fn_i18n("_PASSWORD") . ":" . "</td><td  $fbackground><input name=\"logpassword\" type=\"password\" /></td></tr>";
	if ( $_FN['remember_login'] == 1 )
	{
		echo "\n<tr>\n<td $fbackground colspan=\"2\" ><div style=\"text-align:center\">";
		echo "" . fn_i18n("_REMEMBERLOGIN");
		echo "\n<input type=\"checkbox\" alt=\"remember_login\" name=\"rememberlogin\"  />";
		echo "\n</div></td></tr>";
	}
	echo "<tr><td $fbackground colspan=\"2\" ><div style=\"text-align:center\"><input type=\"submit\" class=\"submit\" value=\"" . fn_i18n("_LOGIN") . "\" /></div></td></tr>";
	echo "<tr><td $fbackground colspan=\"2\" ><div style=\"text-align:center\">";
	$_FORGPASS = fn_i18n("_FORGPASS");
	$ak = getaccesskey($_FORGPASS,"login&amp;op=rec_pass");
	echo "<a accesskey=\"$ak\" href=\"?mod=login&amp;op=rec_pass\">$_FORGPASS</a>";
	echo "</div></td></tr>";
	echo "</tbody></table>";
	closeloginform();
	echo "</form>";
	if ( $_FN['enable_registration'] == 1 )
	{
		echo "<div style=\"text-align:center\">";
		echo fn_i18n("_NONREG") . "<br />";
		$tit = fn_i18n("_REGORA");
		echo "<a accesskey=\"" . getaccesskey($tit,"login&amp;op=vis_reg") . "\" href=\"?mod=login&amp;op=vis_reg\"><b>$tit</b></a>";
		echo "</div>";
	}
}

/**
 * Visualizza il profilo dell' utente
 *
 **/
function profile()
{
	global $_FN;
	global $forumback,$forumborder;
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "style=\"background-color:#$forumborder;margin:auto;\" cellspacing=\"1\" cellpadding=\"2\"";
	$fbackground2 = $forumback;
	if ( $forumback != "" )
	{
		$fbackground = "style=\"background-color:#$forumback\"";
		$fbackground2 = "style=\"background-color:#$forumback;text-align:center;vertical-align:center\"";
	}
	$user = getparam("user",PAR_GET,SAN_FLAT);
	if ( $user == "" )
		$user = $_FN['user'];
	$uservalues = get_user($user);
	openloginform();
	if ( $_FN['user'] != "" )
	{
		if ( isset($uservalues['avatar']) && $uservalues['avatar'] != "" )
			$image = $_FN['datadir'] . "/fndatabase/users/$user/avatar/thumbs/" . $uservalues['avatar'] . ".jpg";
		else
		{
			if ( isset($uservalues['avatarimage']) && $uservalues['avatarimage'] != "" )
			{
				$image = ($_FN['datadir'] . "/fndatabase/avatars/" . urlencode($uservalues['avatarimage']) . "/filename/" . $uservalues['avatarimage']);
			}
			else
				$image = fromtheme("images/avatars/blank.png");
		}
		echo "<table  $fbackborder><tbody>";
		echo "<tr>";
		echo "<td $fbackground2 colspan=\"2\" rowspan=\"1\"  >";
		echo "<b>$user</b><br />";
		echo "<img src=\"$image\" alt=\"$user\" /><br />";
		if ( $_FN['user'] == $user || is_admin() )
		{
			echo "<a href=\"?mod=" . $_FN['mod'] . "&amp;op=modprof&amp;user=$user\" >" . fn_i18n("_FMODPROF") . "</a> ";
		}
		echo "</td>";
		echo "</tr>";

		$fields = new FieldForm("fndatabase","users",$_FN['datadir'],$_FN['lang']);
		foreach ( $fields->formvals as $key=>$value )
		{
			if ( (isset($value['showinprofile']) && $value['showinprofile'] == 1) )
			{
				if ( $key == 'email' &&  !isadmin() )
				{
					if ( isset($uservalues['emailhidden']) && $uservalues['emailhidden'] == 1 ) //gli amministratori vedono tutte le email
						continue;

				}
				echo "<tr>";
				echo "<td  $fbackground ><b>" . $value['title'] . ":</b></td>";
				echo "<td  $fbackground >" . htmlentities($uservalues[$key]) . "</td>";
				echo "</tr>";
			}
		}

		echo "</tbody></table>";

		// se sono io che modifico il mio profilo o sono un'amministratore
		if ( ($user == $_FN['user']) || is_admin() )
		{
			if ( $_FN['enable_account_deletion'] == 1 )
			{
				echo "<br /><b><a href='#' onclick=\"check('?mod=" . $_FN['mod'] . "&amp;op=deluser&amp;user=" . $user . "')\">" . fn_i18n("_FDELUTENTE") . "</a></b>&nbsp;&#124;&nbsp;";
			}
			echo "<b><a href=\"?mod=" . $_FN['mod'] . "&amp;op=modprof&amp;user=" . $user . "\" >" . fn_i18n("_FMODPROF") . "</a></b>&nbsp;&#124;&nbsp;";
			echo "<b><a href=\"?mod=" . $_FN['mod'] . "&amp;op=logout&amp;user=" . $user . "\" >" . fn_i18n("_LOGOUT") . "</a></b>";
		}

	}
	else
	{
		echo "" . fn_i18n("_FERRACC") . "";
	}
	closeloginform();
}

/**
 * modifica il profilo
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 **/
function modprof()
{
	global $_FN;
	global $forumback,$forumborder;

	$user = getparam("user",PAR_GET,SAN_FLAT);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	if ( $user == "" )
		$user = $_FN['user'];
	$req = getparam("REQUEST_URI",PAR_SERVER,SAN_FLAT);
	$uservalues = get_user($user);
	if (  !$uservalues )
		return;
	$olduservalues = $uservalues;
	openloginform();
	// io posso modificare il mio profilo
	// l'amministratore pu? modificare tutti i profili
	if ( ($user == $_FN['user']) || is_admin() )
	{
		echo "<form enctype=\"multipart/form-data\" action=\"?mod=" . $_FN['mod'] . "&amp;opt=$op&amp;op=reg_sic\" method=\"post\" name=\"registra\" >";
		echo "<fieldset>";
		echo "<legend>" . fn_i18n("_FMODPROFTIT") . " $user</legend>";
		echo "\n<table >" . "\n<tbody>";
		echo "\n<tr>" . "\n<td style=\"text-align:center\" colspan=\"2\" >";
		//apre la tabella --<
		echo "<b>" . fn_i18n("_FCAMPI") . "</b><br />&nbsp;";
		echo "</td>";
		echo "</tr>";

		$level = $uservalues['level'];
		$group = $uservalues['group'];
		$_fnextrauservalues = new FieldForm("fndatabase","users",$_FN['datadir'],$_FN['lang']);
		$_fnextrauservalues->setlayoutTags("<tr><td style=\"text-align:right;vertical-align:top\">","</td>","<td>","</td></tr>");
		$_fnextrauservalues->ShowUpdateForm($user,isadmin());

		if ( isadmin() )
		{
			//livello-->
			echo "<tr><td>" . fn_i18n("_LEVEL") . "</td>";
			echo "<td>";
			echo "<select name=\"level\">";
			for ( $i = 0;$i < 11;$i++  )
			{
				if ( $level == $i )
					echo ("<option value=\"$i\" selected >$i</option>");
				else
					echo ("<option value=\"$i\" >$i</option>");
			}
			echo "</select>";
			echo "</td></tr>";
			//livello--<
			//gruppo-->
			echo "<tr><td>" . fn_i18n("_FGRUPPO") . "</td>";
			echo "<td>";
			$groups = get_grouplist();
			$grlist = explode(",",$group);
			foreach ( $groups as $g )
			{
				$ck = in_array($g,$grlist) ? "checked=\"true\"" : "";
				print("<input $ck name=\"group-$g\" value=\"$group\" type=\"checkbox\" />$g<br />");
			}
			echo "</td></tr>";
			//gruppo--<
		}
		//invia--<
		$op = getparam("opt",PAR_GET,SAN_FLAT);
		echo "<tr><td>&nbsp;</td><td><br /><input type=\"submit\" class=\"submit\" value=\"" . fn_i18n("_SAVE") . "\" />&nbsp;<input type=\"button\" onclick=\"window.location='?mod={$_FN['mod']}'\" class=\"submit\" value=\"" . _CANCEL . "\" /></td></tr>";
		//invia--<
		echo "</tbody></table>";

		$fields = new FieldForm("fndatabase","users",$_FN['datadir'],$_FN['lang']);
		$prk = $fields->xmltable->primarykey;
		$nome = $uservalues[$prk] = $uservalues[$prk];

		echo "<input type=\"hidden\" name=\"$prk\" value=\"$nome\" />";
		echo "</fieldset>";
		echo "</form>";
		closeloginform();

	}
}

/**
 * members
 *
 *
 */
function members()
{
	global $_FN,$member_per_page,$min_level_members;
	$loginsection = find_section("login");
	include ("sections/$loginsection/config.php");
	global $forumback,$forumborder;
	$fbackborder = "";
	$fbackground = "";
	if ( $forumborder != "" )
		$fbackborder = "style=\"background-color:#$forumborder;margin:auto;\" cellspacing=\"1\" cellpadding=\"2\"";
	if ( $forumback != "" )
		$fbackground = "style=\"background-color:#$forumback\"";

	$pages = null;
	$page = getparam("page",PAR_GET,SAN_FLAT);
	$op = getparam("opt",PAR_GET,SAN_FLAT);
	$opmod = getparam("op",PAR_GET,SAN_FLAT);
	$order = getparam("order",PAR_GET,SAN_FLAT);

	if ( $page == "" )
	{
		$page = 0;
	}
	if ( $page != 0 )
	{
		$page = $page - 1;
	}

	openloginform();
	echo "<table width=\"100%\" $fbackborder><tbody>";
	echo "<tr>";
	$colspan = 1;
	$fields = new FieldForm("fndatabase","users",$_FN['datadir'],$_FN['lang']);
	if ( getlevel($_FN['user']) >= $min_level_members )
	{
		echo "<td $fbackground ><a href=\"?mod=" . $_FN['vmod'] . "&amp;op=$opmod&amp;opt=$op&amp;order=username\"><b>" . _NOMEUTENTE . "</b></a></td>";
		if ( isset($fields->formvals['name']) )
		{
			$colspan++ ;
			echo "<td $fbackground ><a href=\"?mod=" . $_FN['vmod'] . "&amp;op=$opmod&amp;opt=$op&amp;order=name\"><b>" . $fields->formvals['name']['title'] . "</a></td>";
		}
		if ( isadmin() )
		{
			$colspan++ ;
			echo "<td $fbackground ><a href=\"?mod=" . $_FN['vmod'] . "&amp;op=$opmod&amp;opt=$op&amp;order=level\"><b>" . _LEVEL . "</b></a></td>";
		}
		if ( $fields->formvals['email']['showinprofile'] == 1 )
		{
			$colspan++ ;
			echo "<td $fbackground ><a href=\"?mod=" . $_FN['vmod'] . "&amp;op=$opmod&amp;opt=$op&amp;order=email\"><b>" . _FEMAIL . "</b></a></td>";
		}
		if ( isset($fields->formvals['link']) )
		{
			$colspan++ ;
			echo "<td $fbackground ><a href=\"?mod=" . $_FN['vmod'] . "&amp;op=$opmod&amp;opt=$op&amp;order=link\"><b>" . $fields->formvals['link']['title'] . "</b></a></td>";
		}

		if ( isadmin() )
		{
			$colspan++ ;
			echo "<td $fbackground ><a href=\"?mod=" . $_FN['vmod'] . "&amp;op=$opmod&amp;opt=$op&amp;order=group\"><b>" . _GRUPPO . "</b></a></td>";
		}
		echo "</tr>";
		$table = new XMLTable("fndatabase","users",$_FN['datadir']);
		$db = new XMLDatabase("fndatabase",$_FN['datadir']);

		$find = getparam("find",PAR_POST,SAN_FLAT);
		$notactive = getparam("notactive",PAR_POST,SAN_FLAT);

		if ( $find == "" && $notactive == "" )
		{
			$members = $table->GetRecords(false,false,false,$order);
		}
		else
		{
			$qact = "";

			if ( $find != "" )
			{
				if ( $notactive != "" )
					$qact = " AND active <> '1'";
				if ( isset($table->fields['username']) )
					$query = 'SELECT * FROM users WHERE (username LIKE "%' . $find . '%" OR email LIKE "%' . $find . '%") ' . $qact;
				else
					$query = 'SELECT * FROM users WHERE (email LIKE "%' . $find . '%")' . $qact;
			}
			else
			{
				$query = "SELECT * FROM users WHERE active <> '1'";
			}

			if ( $order != "" )
				$query .= ' ORDER BY ' . $order;

			$members = $db->Query($query);

			$member_per_page = count($members);
		}
		$prk = $table->primarykey;
		for ( $x = $page * $member_per_page;$x < $member_per_page * ($page + 1);$x = $x + 1 )
		{
			if ( isset($members[$x]) )
			{

				print "<tr>";
				print "<td $fbackground >";
				$uservalues = $members[$x];
				$tmp = $uservalues[$prk]; //username
				print "<a href=\"?mod=" . $_FN['mod'] . "&amp;opt=$op&amp;op=profile&amp;user=$tmp\" >$tmp</a><br />";
				print "</td>";
				if ( isset($fields->formvals['name']) ) //nome
					print "<td $fbackground  align='center'>" . htmlentities($uservalues['name']) . "</td>";
				if ( isadmin() ) //livello
					print "<td $fbackground >" . $uservalues['level'] . "</td>";
				if ( isadmin() || $fields->formvals['email']['showinprofile'] == 1 ) //email
				{
					print "<td $fbackground >";

					if ( ( !isset($uservalues['emailhidden']) || $uservalues['emailhidden'] == 0) || is_admin() ) //gli amministratori vedono tutte le email
						echo "<a href=\"mailto:" . htmlentities($uservalues['email']) . "\" >" . htmlentities(str_replace(".","[dot]",str_replace("@","[at]",$uservalues['email']))) . "</a>";
					echo "</td>";
				}
				if ( isset($fields->formvals['link']) ) //link
					print "<td  $fbackground ><a href=\"" . htmlentities($uservalues['link']) . "\" onclick=\"window.open(this.href);return false;\" >" . htmlentities($uservalues['link']) . "</a></td>";
				if ( isadmin() ) //gruppo
					print "<td  $fbackground >" . $uservalues['group'] . "</td>";
				print "</tr>";
			}
		}
		if ( count($members) > $member_per_page )
		{
			$pages = "";
			for ( $thispagenum = 1;$thispagenum <= ceil(count($members) / $member_per_page);$thispagenum = $thispagenum + 1 )
			{
				if ( $thispagenum != ($page + 1) )
					$pages = $pages . "[<a href=\"".fn_rewritelink("?mod=" . $_FN['mod'] . "&amp;op=$opmod&amp;opt=$op&amp;order=$order&amp;page=" . $thispagenum) . "\">" . $thispagenum . "</a>] ";
				else
					$pages = $pages . "[" . $thispagenum . "] ";
			}
		}
		if ( $find != "" )
			$pages = count($members) . " " . fn_i18n("_USERS");
		if ( count($members) == 0 )
			$pages = fn_i18n("_NORESULT");

		echo "<tr><td  $fbackground style=\"text-align:center\" colspan=\"$colspan\">$pages</td></tr>";
	}
	else
	{
		if ( $min_level_members == 0 )
		{
			print "<td $fbackground >" . fn_i18n("_FERRACC") . "</td></tr>";
		}
		else
			print "<td $fbackground >" . fn_i18n("_NOLEVELSECT") . "</td></tr>";

	}
	echo "</tbody></table>";
	closeloginform();

}

/**
 * anti_spam
 *
 */
function anti_spam($str)
{
	$encoded = bin2hex($str);
	$encoded = chunk_split($encoded,2,'%');
	$encoded = '%' . substr($encoded,0,strlen($encoded) - 1);
	return $encoded;
}
/**
 * esegue l'update di un utente
 *
 **/
function reg_sic($goto = "")
{
	global $_FN;

	if ( $goto == "" )
		$goto = "?mod=" . $_FN['mod'];
	$fields = new FieldForm("fndatabase","users",$_FN['datadir'],$_FN['lang']);

	if ($_FN['user']=="" && $_FN['enable_registration'] == 0 &&  !is_admin() )
	{
		echo fn_i18n("_NONPUOI");
		return;
	}
	$nome = getparam($fields->xmltable->primarykey,PAR_POST,SAN_FLAT);
	// se non e' il vero utente esco
	if (  !versecid($_FN['user']) )
		die(fn_i18n("_NONPUOI"));
	$table = new XMLTable("fndatabase","users",$_FN['datadir']);
	$oldvalues = $table->GetRecordByPrimaryKey($nome);
	openloginform();

	// io posso modificare il mio ma solo se mantengo il livello!!!
	// l'amministratore puo' modificare tutti i profili
	$newvalues = $fields->getbypost();

	if ( (isadmin() || $nome == $_FN['user']) && count($newvalues) > 0 && $_FN['user'] != "" )
	{
		//------------riempo i campi--------------------
		//metto la password in md5
		if ( ($newvalues['passwd'] != "") )
		{
			$newvalues['passwd'] = md5($newvalues['passwd']);
		}
		else
			$newvalues['passwd'] = $oldvalues['passwd'];


		// solo un amministratore puo cambiare il livello
		if (  !isadmin() )
		{
			$newvalues['level'] = $oldvalues['level'];
			$newvalues['active'] = $oldvalues['active'];
			//se e' abilitata la registrazione con controllo per email
			if ($_FN['registration_by_email'] == 1)
			{
				$newvalues['email'] = $oldvalues['email'];
			}
		}
		$prk = $fields->xmltable->primarykey;
		//metto la chiave primaria
		$newvalues[$prk] = $oldvalues[$prk];
		// solo un amministratore puo' cambiare il gruppo
		if ( isadmin() )
		{
			//compongo la stringa del gruppo
			$groups = get_grouplist();
			$newgroup = "";
			$i = 0;
			foreach ( $groups as $g )
			{
				if ( isset($_POST['group-' . $g]) )
					$newgroup .= $g . ",";
				$i++ ;
			}
			if ( $newgroup != "" )
				$newgroup = substr($newgroup,0,strlen($newgroup) - 1);
			$newvalues['group'] = $newgroup;
		}
		else
		{
			$newvalues['group'] = $oldvalues['group'];

		}
		//---------per i valori che mancano metto quelli nuovi
		foreach ( $oldvalues as $k=>$v )
		{
			if (  !isset($newvalues[$k]) )
			{
				$newvalues[$k] = $oldvalues[$k];
			}
		}
		//-------------conrollo dei campi---------------------------
		$err = $fields->Verify($newvalues,true);
		if ( $err == "" )
		{
			//----------aggiornamento dei campi-----------------------
			$newvalues = $fields->xmltable->UpdateRecord($newvalues);
			///	dprint_r($newvalues);
			FN_log("User $nome profile modified.");

			if ( $_FN['user'] == $newvalues[$prk] )
			{
				fn_login($_FN['user']);
			}
			//se l' utente  stato attivato a mano invia la mail
			if ( is_admin() && $newvalues['active'] == 1 && $oldvalues['active'] == 0 )
				fn_send_mail_registration($newvalues[$prk]);
			echo fn_i18n("_FOKMODPROF");
		}
		else
		{
			echo fn_i18n("_FERRCAMPO") . ":<br /><br />";
			echo "$err<br />";
			$tit = fn_i18n("_INDIETRO");
			echo "<a accesskey=\"" . getaccesskey($tit,"javascript:history.back()") . "\" href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
		}
		echo "<br /><br />";
		if ( $err == "" )
		{
			$tit = fn_i18n("_AVANTI");
			echo "<a accesskey=\"" . getaccesskey($tit,"$goto") . "\" href=\"$goto\">$tit  &gt;&gt;&gt;</a><br /><br />";
		}
	}
	else
		echo fn_i18n("_NONPUOI");
	closeloginform();
}

/**
 * is_logged_in
 *
 * @return bool true if is logged in
 *
 */
function is_logged_in()
{
	global $_FN;
	if ( $_FN['user'] != "" )
		return true;
	return false;
}

/**
 * Invia mail di registrazione
 *
 * @param string $username
 */
function fn_send_mail_registration($username)
{
	global $_FN;
	$user_data = get_user($username);
	$mail_welcome_message = file_get_contents("{$_FN['datadir']}/messages/{$_FN['lang']}/mail_welcome_message.txt");
	$mail = str_replace("!USERNAME!",$username,$mail_welcome_message);
	$mail = str_replace("!SITENAME!",$_FN['sitename'],$mail);
	//fix newline
	$mail = FN_fixnewline($mail);
	mail($user_data['email'],fn_i18n("_FREG") . " " . $_FN['sitename'],$mail,"From: {$_FN['site_email_address']}");
}

/**
 * completamento della registrazione
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 **/
function end_reg()
{
	global $_FN;
	$username = getparam("user",PAR_GET,SAN_FLAT);
	$userid = getparam("id",PAR_GET,SAN_FLAT);

	//---------------------------------completamento registrazione--------------------------------------------
	if ( isset($_GET['registra']) && $username != "" )
	{
		$user_data = get_user($username);
		if ( $user_data['active'] == 0 )
		{
			if ( validate_user($username,$userid) == true )
			{
				echo "<br />" . fn_i18n("_REG_OK") . "<br />";
				echo "<br /><div ><a href=\"index.php\">" . fn_i18n("_RETURN_HOME") . "</a></div>";
				//send a mail to confirm the registration
				// messaggio personalizato in config.php
				fn_send_mail_registration($username);
				//send a mail to Administrator
				if ( $_FN['enable_log_email'] == 1 )
				{
					mail($_FN['log_email_address'],"new user",FN_fixnewline($username . "\n" . "email : " . $user_data['email'] . "\n" . "ip : " . $user_data['ip']),"From: {$_FN['site_email_address']}");
				}
				if ( function_exists("FN_OnValidateUsers") )
				{
					FN_OnValidateUsers($user_data);
				}
				return true;
			}
			else
				echo fn_i18n("_ERROR_REG") . "<br />";
		}
		else
		{
			if ( user_exists($username) == true )
			{
				echo "<br />" . fn_i18n("_USER_REGIST") . "<br />";
			}
			else
				echo fn_i18n("_ERROR_REG") . "<br />";
			$tit = fn_i18n("_RETURN_HOME");
			$accesskey = getaccesskey($tit,"index.php");
			echo "<br /><div ><a accesskey='$accesskey' href=\"index.php\">" . $tit . "</a></div>";
			return false;
		}
	}
	return false;
}

/**
 * valida un settando active a 1
 *
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @param  $user nome utente
 * @param  $rnd  numero casuale generato durante la registrazione che serve come verifica di autenticit?
 *
 * @return bool
 *
 **/
function validate_user($user, $rnd)
{
	global $_FN;
	$us = get_user($user);
	if ( $us['rnd'] == $rnd )
		$us['active'] = 1;
	else
		return false;
	$table = new XMLTable("fndatabase","users",$_FN['datadir']);
	$table->UpdateRecord($us);
	return true;
}

?>