<?php
/**
 * @package flatnux_section_login
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 * @copyright Copyright (c) 2003-2005
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 */
if ( strpos(strtolower($_SERVER['SCRIPT_NAME']),strtolower(basename(__FILE__))) )
{
	header("Location: ../../index.php");
	die("...");
}
global $_FN;
//--- da config --
global $member_per_page,$member_per_page;
global $confirmation_message;
include ("sections/{$_FN['vmod']}/config.php");
include ("sections/{$_FN['vmod']}/login_functions.php");
$op = getparam("op",PAR_POST,SAN_FLAT);
if ( $op == "" )
	$op = getparam("op",PAR_GET,SAN_FLAT);
$opmod = getparam("opmod",PAR_GET,SAN_FLAT);
if ( $opmod != "" )
	$op = $opmod;
$getuser = getparam("user",PAR_GET,SAN_FLAT);
$from = getparam("from",PAR_SERVER,SAN_FLAT);
if ( $from == "" )
	$from = "index.php";
switch ($op)
{
	case "deluser" :
		if ( ($getuser == $_FN['user']) || (isadmin()) )
		{
			if ( $getuser == $_FN['user'] )
			{
				fn_logout();
			}
			if ( $_FN['enable_account_deletion'] == 1 || is_admin() )
			{
				fn_delete_user($getuser);
				echo "<script language=javascript>window.location='index.php';</script>";
			}
		}
	break;
	case "logout" :
		logout();
	break;
	case "login" :
		login();
	break;
	case "vis_reg" :
		vis_reg();
	break;
	case "reg_sic" :
		reg_sic();
	break;
	case "reg" :
		if ( reg() )
		{
			echo "<br /><br />" . fn_i18n("_FORAREG");
			echo "<br /><br /><a href=\"?mod={$_FN['mod']}\">" . fn_i18n("_AVANTI") . " &gt;&gt;</a>";
		}
	break;
	case "vis_login" :
		vis_login();
	break;
	case "send_pass" :
		send_pass();
	break;
	case "send_rnd" :
		send_rnd();
	break;
	case "members" :
		members();
	break;
	case "modprof" :
		modprof();
	break;
	case "profile" :
		profile();
	break;
	case "end_reg" :
		end_reg();
	break;
	case "rec_pass" :
		rec_pass();
	break;
	default :
		vis_login();
	break;
}
/**
 * esegui il login
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 **/
function login()
{
	global $_FN;
	$logpassword = getparam("logpassword",PAR_POST,SAN_FLAT);
	$from = getparam("from",PAR_POST,SAN_FLAT);
	$nome = getparam("nome",PAR_POST,SAN_FLAT);
	$from = sectionlocation($from);
	if ( $from == "" )
		$from = "index.php";
	else
		$from = "index.php?mod=$from";
	openloginform();
	if (  !user_exists($nome) || ($nome == "") )
	{
		echo "<br /><br />";
		$tit = fn_i18n("_REGORA");
		echo "<b>" . htmlspecialchars($nome) . "</b> " . fn_i18n("_FNONREG") . "<br /><br />";
		echo "<a accesskey=\"" . getaccesskey($tit,$_FN['mod'] . "&amp;op=vis_reg") . "\" href=\"?mod={$_FN['mod']}&amp;op=vis_reg\" >$tit&gt;&gt;</a>";
	}
	else
	{
		$us = get_user($nome);
		if ( $us != null && fn_verify_user_password($nome,$logpassword) )
		{
			if ( $us['active'] == 1 )
			{
				fn_login($nome);
				jsredirect($from);
			}
			else
			{
				$tit = fn_i18n("_INDIETRO");
				echo "\n\t\t<b>$nome</b> " . fn_i18n("_FNNOTCOMPLETEREG") . "<br /><a accesskey=" . getaccesskey($tit,"javascript:history.back()") . " href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
			}
		}
		else
		{
			echo "<br /><br />";
			$tit = fn_i18n("_INDIETRO");
			echo "<b>$nome</b> " . fn_i18n("_FERRPASS") . "<br /><br /><a accesskey=" . getaccesskey($tit,"javascript:history.back()") . " href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
			$_FORGPASS = fn_i18n("_FORGPASS");
			$ak = getaccesskey($_FORGPASS,"login&amp;op=rec_pass");
			echo "<br /><br /><a accesskey='$ak' href=\"?mod=login&amp;op=rec_pass\">$_FORGPASS</a>";
		}
	}
	closeloginform();
}
/**
 * esegue il logout
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 **/
function logout()
{
	fn_logout();
	jsredirect("index.php");
}
/**
 * user_exists
 * verifica che un utente esista.
 * l' utente viene considerato esistente anche se non ha completato la registrazione
 * @param string $user nome utente
 * @return bool
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 **/
function user_exists($user)
{
	if ( get_user($user) == null )
		return false;
	else
		return true;
}
/**
 * get_access_ok
 * verifica username e password
 * @param $user nome utente
 * @param $password password
 * @return bool
 **/
function get_access_ok($user, $password)
{
	if ( user_exists($user) != true )
		return false;
	$UserValues = array();
	$UserValues = get_user($user);
	if ( strcmp(md5($password),$UserValues['passwd']) == 0 )
	{
		return true;
	}
	return false;
}
/**
 * rec_pass
 * recupero password dimenticata.
 * Genera una nuova password e la invia per email
 **/
function rec_pass()
{
	global $_FN;
	openloginform();
	echo "<form action='?mod=login&amp;op=send_rnd' method=\"post\">";
	echo "<h2>" . fn_i18n("_FORGPASS") . "</h2>";
	echo fn_i18n("_RECPASSNOTICE");
	echo "<br /><br />" . fn_i18n("_NOMEUTENTE") . ":";
	echo "&nbsp;<input size=\"20\" name=\"nome\" type=\"text\" />";
	echo "&nbsp;<input type=\"submit\" class=\"submit\" value=\"" . fn_i18n("_FINVIA") . "\" />";
	$tit = fn_i18n("_CANCEL");
	echo "<br /><br /><input accesskey=\"" . getaccesskey($tit,"javascript:history.back()") . "\" onclick=\"javascript:history.back()\"  class=\"button\" type=\"button\" value=\"$tit\" />";
	echo "</form>";
	closeloginform();
}
/**
 * send_pass
 * recupero password dimenticata.
 * Genera una nuova password e la invia per email
 **/
function send_pass()
{
	global $_FN;
	$err = "";
	$nome = getparam("nome",PAR_POST,SAN_FLAT);
	if ( $nome == "" )
		$nome = getparam("nome",PAR_GET,SAN_FLAT);
	if ( $nome == "" || stristr($nome," ") || strlen($nome) > 30 || (stristr($nome,"\"")) )
		$err .= fn_i18n("_ERRUSERNAME") . "<br />";
	if ( user_exists($nome) != true )
		$err .= htmlspecialchars($nome) . " : " . fn_i18n("_FNONREG") . "<br />";
	if ( $err != "" )
	{
		echo "$err<br />";
		$tit = fn_i18n("_INDIETRO");
		echo "<a accesskey=\"" . getaccesskey($tit,"javascript:history.back()") . "\" href=\"javascript:history.back()\">&lt;&lt;$tit</a>";
		return;
	}
	$user_data = get_user($nome);
	//-----genero una nuova password---------
	$chrs = array('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z');
	$newpass = "";
	for ( $i = 0;$i < 10;$i++  )
	{
		$ch = rand(0,35);
		$newpass .= $chrs[$ch];
	}
	$newpassmd5 = md5($newpass);
	$user_data['passwd'] = $newpassmd5;
	$table = new XMLTable("fndatabase","users",$_FN['datadir']);
	$table->UpdateRecord($user_data);
	//recupero l' indirizzo del server
	$server = $_FN['siteurl'] . "index.php";
	$mail = fn_i18n("_FNEWPASS") . "\n$newpass\n\n$server";
	$mail = FN_fixnewline($mail);
	//invio la mail
	mail($user_data['email'],$_FN['sitename'] . " - " . fn_i18n("_FORGPASS"),$mail,"From: {$_FN['site_email_address']}");
	$addr = getparam("REMOTE_ADDR",PAR_SERVER,SAN_FLAT);
	FN_log("User $nome recover password step II.");
	openloginform();
	echo "<form action=\"?mod=login\" method=\"post\">";
	echo "<table><tbody>";
	echo "<tr><td colspan=\"2\">";
	echo "<b>" . fn_i18n("_RECPASSESENDMAIL") . "</b></td></tr>";
	echo "<tr><td colspan=\"5\">";
	$home = fn_i18n("_RETURN_HOME");
	$ak = getaccesskey($home,"index.php");
	echo "<a accesskey=\"$ak\" href=\"index.php\">$home</a></td></tr>";
	echo "</tbody></table></form>";
	closeloginform();
}
/**
 * send_rnd
 * recupero password dimenticata.
 * Genera una nuova rnd e la invia per email
 **/
function send_rnd()
{
	global $_FN;
	$err = "";
	$nome = getparam('nome',PAR_POST,SAN_HTML);
	$nome_ori = getparam('nome',PAR_POST,SAN_FLAT);
	if ( $nome == "" || stristr($nome," ") || strlen($nome) > 43 || (stristr($nome,"\"")) )
		$err .= fn_i18n("_ERRUSERNAME") . "<br />";
	if ( user_exists($nome_ori) != true )
		$err .= $nome . " : " . fn_i18n("_FNONREG") . "<br />";
	if ( $err != "" )
	{
		echo "$err<br />";
		$tit = fn_i18n("_INDIETRO");
		echo "<a accesskey=\"" . getaccesskey($tit,"javascript:history.back()") . "\" href=\"javascript:history.back()\">&lt;&lt;" . $tit . "</a>";
		return;
	}
	$user_data = get_user($nome_ori);
	//-----genero una nuova password---------
	$chrs = array('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z');
	$newpass = "";
	for ( $i = 0;$i < 10;$i++  )
	{
		$ch = rand(0,35);
		$newpass .= $chrs[$ch];
	}
	$newpassmd5 = md5($newpass);
	$user_data['rnd'] = $newpassmd5;
	$table = new XMLTable("fndatabase","users",$_FN['datadir']);
	$table->UpdateRecord($user_data);
	//recupero l' indirizzo del server
	$server = $_FN['siteurl'] . "index.php?mod=login&op=send_pass&nome=$nome&rnd=$newpassmd5";
	$mail = fn_i18n("_FORGPASS") . "\n" . "\n" . fn_i18n("_RECPASSNOTICE2") . ":\n$server\n\n" . fn_i18n("_RECPASSNOTICE");
	//fix newline
	$mail = FN_fixnewline($mail);
	//invio la mail
	mail($user_data['email'],$_FN['sitename'] . " - " . fn_i18n("_FORGPASS"),$mail,"From: {$_FN['site_email_address']}");
	//dprint_r($mail);
	FN_log("User $nome recover password step 1.");
	openloginform();
	echo "<form action=\"?mod=login\" method=\"post\">";
	echo "<table  ><tbody>";
	echo "<tr><td  colspan=\"2\">";
	echo "<b>" . fn_i18n("_RECPASSESENDMAIL1") . "</b></td></tr>";
	echo "<tr><td  colspan=\"2\">";
	$home = "<br />" . fn_i18n("_RETURN_HOME") . " &gt;&gt;";
	$ak = getaccesskey($home,"index.php");
	echo "<a accesskey=\"$ak\" href=\"index.php\">$home</a></td></tr>";
	echo "</form></tbody></table>";
	closeloginform();
}
?>