<?php
if ( !file_exists("./index.php") || !file_exists("./sections") )
	die();

/**
 * 10_Google_sitemap.php created on 10/dic/2008
 *
 * 
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 */
global $_FN;
$op = getparam("opt", PAR_GET, SAN_FLAT);
$opmod = getparam("opmod", PAR_GET, SAN_FLAT);

if ( !file_exists("sitemap.xml") && !is_writable(".") )
{
	echo "<b>" . fn_i18n("_ERROR_PERM") . "</b><br /><br />" . fn_i18n("_ERROR_PERM_FIX1");
	echo "<br /><pre>" . dirname($_SERVER['SCRIPT_FILENAME']) . "</pre>";
}
else
if ( file_exists("sitemap.xml") && !is_writable("sitemap.xml") )
{
	echo "sitemap.xml : " . fn_i18n("_READONLY") . "<br />";
}
else
{
	if ( $opmod == "update" )
	{
		fn_create_google_sitemap("sitemap.xml");
		jsalert("googlesiteap.xml updated");
	}
	echo "<a href=\"?opt=$op&amp;opmod=update\">Update sitemap.xml</a><br />";
}
$imghelp = "<img style=\"vertical-align:middle\" alt=\"\" src=\"" . fromtheme("images/icons/help.png") . "\"/>";
echo "<div style=\"text-align:right\">$imghelp&nbsp;<a href=\"https://www.google.com/webmasters/tools/docs/{$_FN['lang']}/about.html\">" . fn_i18n("_FGUIDA") . "</a></div>";
if ( file_exists("sitemap.xml") )
{
	echo "<pre style=\"border:1px inset;height:300px;overflow:auto;\">" . htmlspecialchars(file_get_contents("sitemap.xml")) . "</pre>";
}
echo "<br /><b>URL sitemep:</b>" . $_FN['siteurl'] . "sitemap.xml<br/>";
/**
 * Crea la sitemap
 *
 * @param string $filename path del file da scrivere
 * @author Alessandro Vernassa <speleoalex@gmail.com>
 *
 */
function fn_create_google_sitemap($filename)
{
	global $_FN;
	$_FN['enable_mod_rewrite'] = $_FN['enable_mod_rewrite_default'];
	$modlist = list_sections_translated("sections", false, true);
	$str = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">";
	foreach ( $modlist as $mod )
	{
		$str .= "\n\t<url><loc>{$_FN['siteurl']}" . fn_rewritelink("index.php?mod=" . get_section_id($mod['link']) . "", "&amp;") . "</loc></url>";
		if ( count($_FN['listlanguages']) > 1 )
		{
			foreach ( $_FN['listlanguages'] as $l )
			{
				if ( $l != $_FN['lang_default'] )
					$str .= "\n\t<url><loc>{$_FN['siteurl']}" .
						fn_rewritelink("index.php?mod=" . get_section_id($mod['link']) . "&amp;lang=$l", "&amp;") . "</loc></url>";
			}
		}
	}
	$str .= "\n</urlset><!-- end -->";
	$handle = fopen($filename, "w");
	fwrite($handle, $str);
	fclose($handle);
	$_FN['enable_mod_rewrite'] = 0;
}
?>