<?php
include ("themes/{$_FN['theme']}/config.php");
function theme_doctype()
{
	return "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">";
}

function FN_SectionFooter()
{


}
function create_h_menu($separator = "|")
{
	global $_FN;
	$modlist = list_sections_translated("sections"); // return array width title - link
	$i = count($modlist);
	//serve per indicizzare tutte le lingue
	$tl = ($_FN['lang'] != $_FN['lang_default']) ? "&amp;lang={$_FN['lang']}" : "";
	foreach ( $modlist as $modl )
	{
		if (  !user_can_view_section($modl['link'],$_FN['user']) )
			continue;
		$link = get_section_id($modl['link']);
		$title = $modl['title'];
		$accesskey = $modl['accesskey'];
		if ( $accesskey != "" )
			$accesskey = "accesskey='$accesskey'";
		if (  --$i == 0 )
			$separator = "";
		echo "<a $accesskey href=\"" . fn_rewritelink("index.php?mod=$link$tl") . "\">$title</a>$separator\n";
	}
}
/**
 * create menu
 */
function create_menu()
{
	global $_FN,$theme,$menu_recursive,$show_icons;
	//echo "<ul>";
	$tl = ($_FN['lang'] != $_FN['lang_default']) ? "?lang={$_FN['lang']}" : "";
	if ( $_FN['home_section'] == "" )
	{
		if ( $show_icons && file_exists("themes/$theme/images/menu.png") )
			echo "<img border=0 src=\"themes/$theme/images/menu.png\" alt=\"home\" />&nbsp;";
		echo "<b><a href=\"index.php$tl\">";
		if ( ($text = getLang("sections/.lang.xml")) != "" )
			echo $text;
		elseif ( defined(_FIRSTBUTTONMENU) )
			echo _FIRSTBUTTONMENU;
		else
			echo "HOME";
		echo "</a></b><br />";
	}
	printsection2("sections",$menu_recursive);
	//echo "<br />";
}
/**
 * Stampa la lista delle sezioni e delle sottosessioni
 *
 * @param string $path dove cercare la sezione (es. sections/01_pippo)
 */
function printsection2($path, $recursive = true)
{
	global $_FN,$theme,$home_section,$show_icons,$show_icons_folder,$hide_user_menu;
	global $menu_recursive_onlyselected,$_FNVMOD;
	static $slevel = 0;
	$modlist = list_sections_translated($path,false,false);
	$slevel++ ;
	$tl = ($_FN['lang'] != $_FN['lang_default']) ? "&lang={$_FN['lang']}" : "";
	foreach ( $modlist as $mod )
	{
		if ($hide_user_menu  && !user_can_view_section($mod['link'],$_FN['user']) )
			continue;
		$tmp = $mod['title'];
		$link = $mod['link'];
		$accesskey = $mod['accesskey'];
		if ( $_FN['home_section'] == "" )
			echo "&nbsp;&nbsp;";
		for ( $i = 1;$i < $slevel;$i++  )
		{
			echo "&nbsp;&nbsp;&nbsp;&nbsp;";
		}
		if ( $slevel == 1 )
		{
			echo "<b>";
		}
		$icon = "";
		if ( $show_icons_folder )
		{
			if ( file_exists("sections/$link/icon.png") )
				$icon = "<img src=\"sections/$link/icon.png\" alt=\"\"/>&nbsp;";
			else
				$icon = "<img src=\"" . fromtheme("images/section.png") . "\" alt=\"\"/>&nbsp;";
		}
		$l = basename($link);
		$numsubsection = count(list_sections_translated("$path/$l",false,false));
		if ( $show_icons && $slevel == 1 )
			if ( $numsubsection > 0 )
				$icon = "<img style=\"vertical-align:middle\" src=\"" . fromtheme("images/icons/down.png") . "\" alt=\"\"/>&nbsp;";
			else
				$icon = "<img style=\"vertical-align:middle\" src=\"" . fromtheme("images/icons/forward.png") . "\" alt=\"\"/>&nbsp;";
		$hlink = get_section_id($link);
		echo "\n\t$icon<a accesskey=\"$accesskey\" href=\"" . fn_rewritelink("index.php?mod=$hlink$tl") . "\">$tmp</a>";
		if ( $slevel == 1 )
		{
			echo "</b>";
		}
		echo "<br />";
		if ( $recursive )
		{
			if ( $menu_recursive_onlyselected && fn_erg('^' . $mod['link'],$_FNVMOD) )
				printsection2("$path/$l");
			else
			{
				if (  !$menu_recursive_onlyselected )
					printsection2("$path/$l");
			}
		}
	}
	$slevel-- ;
}
function fn_th_loginform()
{
	global $_FN;
	if ( $_FN['user'] == "" )
	{
		$table = new XMLTable("fndatabase","users","{$_FN['datadir']}");
		echo "<form method=\"post\" action=\"?mod=" . $_FN['mod'] . "&amp;fnlogin=login\" ><div>";
		echo "<label for=\"username\">";
		if ( $table->primarykey == "email" )
			echo fn_i18n("_FEMAIL");
		else
			echo fn_i18n("_NOMEUTENTE");
		echo "</label>";
		echo " <input type=\"text\" size=\"15\" name=\"username\" /> ";
		echo "<label for=\"password\">";
		echo _PASSWORD . "</label><input type=\"password\" size=\"15\" name=\"password\" />";
		echo "&nbsp;<input type=\"submit\" value=\"" . _LOGIN . "\" />";
		$fnlogin = getparam("fnlogin",PAR_GET,SAN_FLAT);
		$fnuser = getparam("username",PAR_POST,SAN_FLAT);
		$fnpwd = getparam("password",PAR_POST,SAN_FLAT);
		if ( $fnlogin == "login" && $fnuser != "" && $fnpwd != "" )
		{
			$lpass = md5($fnpwd);
			$us = get_user($fnuser);
			$passwd = $us['passwd'];
			if ( $passwd != $lpass )
			{
				echo " " . _PASSERR;
			}
		}
		echo "</div></form>";
	}
	else
	{
		echo "{$_FN['user']} : <a href=\"index.php?fnlogin=logout\">" . fn_i18n("_LOGOUT") . "</a>";
	}
}
?>